// stereo.cpp : Defines the entry point for the console application.
//

//-------------------------------------------------------------------------
//				  PRESENTATION
//-------------------------------------------------------------------------
/* Ce programme va ouvrir les 2 images (image_g.bmp et image_d.bmp) et va vrifier que ce sont bien des images bitmap codes en 24 bits.
Si c'est bon, le programme va ensuite enregistrer leur contenu dans des fichiers.*/


#include "stdafx.h"
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <malloc.h>
#include<stdlib.h>
#include<process.h>
#include<dos.h>
#include<ctype.h>

void stereo(void);
void controleimage(void);
void initialise (char *,int);
int conversion(int,int,int);
int calcullargeur(void);
int calculhauteur(void);
int calcultaillefichier(void);
int calcultailleimage(void);
void copieimagememoire(char *,char *,int);
void tableaucouleurs(char *,char *,int,int,int,int);
void tableaucouleur3(char *,char *,int *,int *,int *,int *,int *,int *,int,int,int);
void copiedisque(int,int,int,int,int *,int *,int *,int *,int *,int *);


//-------------------------------------------------------------------------
//				  M A I N
//-------------------------------------------------------------------------

void main (void)
{	
	stereo();
}

 //-------------------------------------------------------------------------
 //                               STEREOVISION
 //---------------------------------------------------------------------------

void stereo (void)
{
	int largeur,hauteur,taillefichier,tailleimage;
	int *tableauR,*tableauG,*tableauB;
	int *tableauRd,*tableauGd,*tableauBd;
	char *corpsimageg,*corpsimaged;


	printf("                       ETAPE 1\n");
	printf("        Controle des images\n\n");
	controleimage();
	largeur=calcullargeur();
	printf("largeur = %d\n",largeur);
	hauteur=calculhauteur();
	printf("hauteur = %d\n",hauteur);
	taillefichier=calcultaillefichier();
	printf("taille fichier = %d\n",taillefichier);
	tailleimage=calcultailleimage();
	printf("taille image = %d\n",tailleimage);
	corpsimageg=(char *) malloc (sizeof(char)*(taillefichier));
	corpsimaged=(char *) malloc (sizeof(char)*(taillefichier));
	copieimagememoire(corpsimageg,corpsimaged,taillefichier);
	tableaucouleurs(corpsimageg,corpsimaged,taillefichier,largeur,hauteur,tailleimage);
	tableauR=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauG=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauB=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauRd=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauGd=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauBd=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableaucouleur3(corpsimageg,corpsimaged,tableauR,tableauRd,tableauG,tableauGd,tableauB,tableauBd,tailleimage,largeur,hauteur);
	copiedisque(taillefichier,tailleimage,largeur,hauteur,tableauR,tableauRd,tableauB,tableauBd,tableauG,tableauGd);
//	free(corpsimageg);
//	free(corpsimaged);
	free(tableauR);
	free(tableauRd);
	free(tableauG);
	free(tableauGd);
	free(tableauB);
	free(tableauBd);
	printf("Fin Partie 1\n\n");
//	getch();

}

 //-------------------------------------------------------------------------
 //                               CONTROLE DES IMAGES
 //---------------------------------------------------------------------------
void controleimage()
{
	FILE *nomfichier;
	char entete[100];
   	nomfichier=fopen("images_originales/image_g.bmp","r");
    if (nomfichier==NULL) 
	{
        printf("\n\nERREUR: Image gauche absente\n");
        printf("(appuyer sur une touche pour quitter)");
		getch();
		exit(-1);
	}
	initialise(entete,100);
	fread(entete,54,1,nomfichier);
	fclose(nomfichier);
	if(!((entete[0]=='B')&&(entete[1]=='M')))
	{
        printf("\n\nERREUR: Image gauche pas BMP\n");
        printf("(appuyer sur une touche pour quitter)");
		getch();
		exit(-1);
	}
	if(entete[28]!=24)
	{
        printf("\n\nERREUR: Image gauche pas 24 bits\n");
        printf("(appuyer sur une touche pour quitter)");
		getch();
		exit(-1);
	}

   	nomfichier=fopen("images_originales/image_d.bmp","r");
    if (nomfichier==NULL) 
	{
        printf("\n\nERREUR: Image droite absente\n");
        printf("(appuyer sur une touche pour quitter)");
		getch();
		exit(-1);
	}
	initialise(entete,100);
	fread(entete,54,1,nomfichier);
	fclose(nomfichier);
	if(!((entete[0]=='B')&&(entete[1]=='M')))
	{
        printf("\n\nERREUR: Image droite pas BMP\n");
        printf("(appuyer sur une touche pour quitter)");
		getch();
		exit(-1);
	}
	if(entete[28]!=24)
	{
        printf("\n\nERREUR: Image gauche pas 24 bits\n");
        printf("(appuyer sur une touche pour quitter)");
		getch();
		exit(-1);
	}
}

 //-------------------------------------------------------------------------
 //                               CALCUL DE LA LARGEUR DE L'IMAGE
 //---------------------------------------------------------------------------
int calcullargeur(void)
{
	FILE *nomfichier;
	char entete[100];
	int largeur;
   	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(entete,100);
	fread(entete,54,1,nomfichier);
	fclose(nomfichier);
	largeur=conversion(entete[18],entete[19],0);
	return largeur;
}

 //-------------------------------------------------------------------------
 //                               CALCUL DE LA HAUTEUR DE L'IMAGE
 //---------------------------------------------------------------------------
int calculhauteur(void)
{
	FILE *nomfichier;
	char entete[100];
	int hauteur;
   	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(entete,100);
	fread(entete,54,1,nomfichier);
	fclose(nomfichier);
	hauteur=conversion(entete[22],entete[23],0);
	return hauteur;
}

 //-------------------------------------------------------------------------
 //                               CALCUL DE LA TAILLE DU FICHIER
 //---------------------------------------------------------------------------
int calcultaillefichier(void)
{
	FILE *nomfichier;
	char entete[100];
	int taillefichier;
   	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(entete,100);
	fread(entete,54,1,nomfichier);
	fclose(nomfichier);
	taillefichier=conversion(entete[2],entete[3],entete[4]);
	return taillefichier;
}

 //-------------------------------------------------------------------------
 //                               CALCUL DE LA TAILLE DE L'IMAGE
 //---------------------------------------------------------------------------
int calcultailleimage(void)
{
	FILE *nomfichier;
	char entete[100];
	int tailleimage;
   	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(entete,100);
	fread(entete,54,1,nomfichier);
	fclose(nomfichier);
	tailleimage=conversion(entete[34],entete[35],entete[36]);
	return tailleimage;
}

 //-------------------------------------------------------------------------
 //                               INITIALISE TABLEAU
 //---------------------------------------------------------------------------

void initialise (char *entete, int M)
{
	int	i=0;
	for(i=0;i<M;i++)
		entete[i]='\0';
}

 //-------------------------------------------------------------------------
 //                               CONVERSION HEXA
 //---------------------------------------------------------------------------

int conversion(int a, int b, int c)
{
	if(a<0)
		a=256+a;
	if(b<0)
		b=256+b;
	if(c<0)
		c=256+c;
	return a+b*256+c*65536;
}

 //-------------------------------------------------------------------------
 //                          COPIE IMAGE DANS TABLEAU
 //---------------------------------------------------------------------------
void copieimagememoire(char *corpsimageg,char *corpsimaged,int taillefichier)
{
	FILE *nomfichier;
   	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(corpsimageg,taillefichier);
	fread(corpsimageg,taillefichier,1,nomfichier);
	fclose(nomfichier);
   	nomfichier=fopen("images_originales/image_d.bmp","r");
	initialise(corpsimaged,taillefichier);
	fread(corpsimaged,taillefichier,1,nomfichier);
	fclose(nomfichier);
}

 //-------------------------------------------------------------------------
 //                          COPIE COULEURS DANS TABLEAU
 //---------------------------------------------------------------------------
void tableaucouleurs(char *corpsimageg,char *corpsimaged,int taillefichier,int largeur,int hauteur,int tailleimage)
{
	int debut=0,i=0;
	debut=taillefichier-tailleimage;

	if((tailleimage-largeur*hauteur*3-(largeur%4)*hauteur)!=0)
	{
		printf("Mauvaise taille de l'image");
        printf("(appuyer sur une touche pour quitter)");
		getch();
		exit(-1);
	}

	if((largeur%4)==0)
		for(i=0;i<(largeur*hauteur*3);i++)
		{
			corpsimageg[i]=corpsimageg[i+debut];
			corpsimaged[i]=corpsimaged[i+debut];
		}

	if((largeur%4)==1)
		for(i=0;i<(largeur*hauteur*3);i++)
		{
			if(((i%(largeur*3))==0)&&(i!=0))
				debut++;
			corpsimageg[i]=corpsimageg[i+debut];
			corpsimaged[i]=corpsimaged[i+debut];
		}

	if((largeur%4)==2)
		for(i=0;i<(largeur*hauteur*3);i++)
		{
			if(((i%(largeur*3))==0)&&(i!=0))
				debut=debut+2;
			corpsimageg[i]=corpsimageg[i+debut];
			corpsimaged[i]=corpsimaged[i+debut];
		}

	if((largeur%4)==3)
		for(i=0;i<(largeur*hauteur*3);i++)
		{
			if(((i%(largeur*3))==0)&&(i!=0))
				debut=debut+3;
			corpsimageg[i]=corpsimageg[i+debut];
			corpsimaged[i]=corpsimaged[i+debut];
		}


	while(i!=taillefichier)
	{
		i++;
		corpsimageg[i]='\0';
		corpsimaged[i]='\0';
	}
}


 //-------------------------------------------------------------------------
 //                          COPIE COULEURS RGB
 //---------------------------------------------------------------------------
void tableaucouleur3(char *corpsimageg,char *corpsimaged,int *tableauR,int *tableauRd,int *tableauG,int *tableauGd,int *tableauB,int *tableauBd,int tailleimage,int largeur, int hauteur)
{
	int i;
	for(i=0;i!=(largeur*hauteur);i++)
	{
		tableauR[i]=corpsimageg[i*3+2];
		tableauRd[i]=corpsimaged[i*3+2];
	}

	for(i=0;i!=(largeur*hauteur);i++)
	{
		tableauG[i]=corpsimageg[i*3+1];
		tableauGd[i]=corpsimaged[i*3+1];
	}

	for(i=0;i!=(largeur*hauteur);i++)
	{
		tableauB[i]=corpsimageg[i*3];
		tableauBd[i]=corpsimaged[i*3];
	}
}


 //-------------------------------------------------------------------------
 //                          COPIE DONNEES SUR LE DISQUE DUR
 //---------------------------------------------------------------------------
void copiedisque(int taillefichier,int tailleimage,int largeur,int hauteur,int *tableauR,int *tableauRd,int *tableauB,int *tableauBd,int *tableauG,int *tableauGd)
{
	FILE *nomfichier;
	int i;

   	nomfichier=fopen("donnees_images/description.txt","w");
	fprintf(nomfichier,"%d\n",taillefichier);
	fprintf(nomfichier,"%d\n",tailleimage);
	fprintf(nomfichier,"%d\n",largeur);
	fprintf(nomfichier,"%d\n",hauteur);
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/couleurRg.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauR[i]<0)
			tableauR[i]=256+tableauR[i];
		fprintf(nomfichier,"%d\n",tableauR[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/couleurRd.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauRd[i]<0)
			tableauRd[i]=256+tableauRd[i];
		fprintf(nomfichier,"%d\n",tableauRd[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/couleurGg.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauG[i]<0)
			tableauG[i]=256+tableauG[i];
		fprintf(nomfichier,"%d\n",tableauG[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/couleurGd.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauGd[i]<0)
			tableauGd[i]=256+tableauGd[i];
		fprintf(nomfichier,"%d\n",tableauGd[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/couleurBg.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauB[i]<0)
			tableauB[i]=256+tableauB[i];
		fprintf(nomfichier,"%d\n",tableauB[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/couleurBd.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauBd[i]<0)
			tableauBd[i]=256+tableauBd[i];
		fprintf(nomfichier,"%d\n",tableauBd[i]);
	}
	fclose(nomfichier);

}