// stereo.cpp : Defines the entry point for the console application.
//

//-------------------------------------------------------------------------
//				  PRESENTATION
//-------------------------------------------------------------------------
/* A partir des images en niveaux de gris, nous allons tcher de dterminer les contours de l'image.
Cela va se faire en 4 tapes
1) Filtrage pour diminuer le bruit
2) Filtre Laplacien pour faire ressortir les contrastes
3) Sorte de gradient pour identifier les contours
4) Elargissements des contours*/


#include "stdafx.h"
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include<stdlib.h>
#include<process.h>
#include<dos.h>
#include<ctype.h>

void stereo(void);
int recdonneesimage(int);
void remplircouleurs(int *,int,int);
void initialise (char *,int);
void lissage(int *,int *,int,int,int,int,int);
void trouvecontours(int *,int *,int,int);
void imagecontour(int *,int,int,int,int,int);
double absolue(int);
void elargircontours(int *,int *,int,int,int,int,int);
void elargircontours2(int *,int *,int,int,int,int,int,int *);

//-------------------------------------------------------------------------
//				  M A I N
//-------------------------------------------------------------------------
void main (void)
{	
	stereo();
}

 //-------------------------------------------------------------------------
 //                               STEREOVISION
 //---------------------------------------------------------------------------
void stereo (void)
{
	int largeur,hauteur,taillefichier,tailleimage;
	int *tableauniveaugris,*tableauniveaugris_d;
	int *tableaucontourfin,*tableaucontourlarge,*tableaulissage;
	int *tableauniveaugris2,*tableauniveaugris_d2;
	int *tableaucontourfin2,*tableaucontourlarge2,*tableaulissage2;

	largeur=recdonneesimage(0);
	hauteur=recdonneesimage(1);
	taillefichier=recdonneesimage(2);
	tailleimage=recdonneesimage(3);
	tableauniveaugris=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauniveaugris_d=(int *) malloc (sizeof(int)*(largeur*hauteur));
	remplircouleurs(tableauniveaugris,largeur*hauteur,1);
	remplircouleurs(tableauniveaugris_d,largeur*hauteur,2);
	tableauniveaugris2=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauniveaugris_d2=(int *) malloc (sizeof(int)*(largeur*hauteur));
	remplircouleurs(tableauniveaugris2,largeur*hauteur,3);
	remplircouleurs(tableauniveaugris_d2,largeur*hauteur,4);

	printf("                       ETAPE 3\n");
	printf("        Trouver les contours\n\n");
	tableaucontourfin=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableaucontourlarge=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableaulissage=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableaucontourfin2=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableaucontourlarge2=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableaulissage2=(int *) malloc (sizeof(int)*(largeur*hauteur));

	printf("lissage image gauche\n");
	lissage(tableauniveaugris,tableaulissage,largeur,hauteur,taillefichier,tailleimage,1);
	printf("Laplacien image gauche\n");
	trouvecontours(tableauniveaugris, tableaucontourfin, largeur, hauteur);
	imagecontour(tableaucontourfin,largeur,hauteur,tailleimage,taillefichier,1);
	printf("Elargissement des contours\n\n");
	elargircontours(tableaucontourlarge, tableaucontourfin, largeur, hauteur,taillefichier, tailleimage,1);

	lissage(tableauniveaugris2,tableaulissage2,largeur,hauteur,taillefichier,tailleimage,3);
	trouvecontours(tableauniveaugris2, tableaucontourfin2, largeur, hauteur);
	imagecontour(tableaucontourfin2,largeur,hauteur,tailleimage,taillefichier,3);
	elargircontours2(tableaucontourlarge2, tableaucontourfin2, largeur, hauteur,taillefichier, tailleimage,3,tableaucontourlarge);	


	printf("lissage image droite\n");
	lissage(tableauniveaugris_d,tableaulissage,largeur,hauteur,taillefichier,tailleimage,2);
	printf("Laplacien image droite\n");
	trouvecontours(tableauniveaugris_d, tableaucontourfin, largeur, hauteur);
	imagecontour(tableaucontourfin,largeur,hauteur,tailleimage,taillefichier,2);
	printf("Elargissement des contours\n");
	elargircontours(tableaucontourlarge, tableaucontourfin, largeur, hauteur,taillefichier, tailleimage,2);

	lissage(tableauniveaugris_d2,tableaulissage2,largeur,hauteur,taillefichier,tailleimage,4);
	trouvecontours(tableauniveaugris_d2, tableaucontourfin2, largeur, hauteur);
	imagecontour(tableaucontourfin2,largeur,hauteur,tailleimage,taillefichier,4);
	elargircontours2(tableaucontourlarge2, tableaucontourfin2, largeur, hauteur,taillefichier, tailleimage,4,tableaucontourlarge);	

	free(tableauniveaugris);
	free(tableauniveaugris_d);
	free(tableaucontourfin);
	free(tableaucontourlarge);
	free(tableauniveaugris2);
	free(tableauniveaugris_d2);
	free(tableaucontourfin2);
	free(tableaucontourlarge2);
	
	printf("\nFin Partie 3 \n\n");
//	getch();
}


 //-------------------------------------------------------------------------
 //                               RECUPERATION DES DONNEES DU FICHIER
 //---------------------------------------------------------------------------

int recdonneesimage(int variable)
{
	FILE *nomfichier;
	int taillefichier,tailleimage,largeur,hauteur;

	nomfichier=fopen("donnees_images/description.txt","r");
	fscanf(nomfichier,"%d",&taillefichier);
	fscanf(nomfichier,"%d",&tailleimage);
	fscanf(nomfichier,"%d",&largeur);
	fscanf(nomfichier,"%d",&hauteur);
	fclose(nomfichier);

	if(variable==0)
		return largeur;
	if(variable==1)
		return hauteur;
	if(variable==2)
		return taillefichier;
	if(variable==3)
		return tailleimage;
	else
		return -1;
}


 //-------------------------------------------------------------------------
 //                               RECUPERATION DES COULEURS
 //---------------------------------------------------------------------------

void remplircouleurs(int *tableauniveaugris,int taille,int variable)
{
	FILE *nomfichier;
	int i;

	if(variable==1)
	{
		nomfichier=fopen("tableaux/niveau_gris_egalisee_g.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&tableauniveaugris[i]);
		fclose(nomfichier);
	}
	if(variable==2)
	{
		nomfichier=fopen("tableaux/niveau_gris_egalisee_d.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&tableauniveaugris[i]);
		fclose(nomfichier);
	}
	if(variable==3)
	{
		nomfichier=fopen("tableaux/niveau_gris_g.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&tableauniveaugris[i]);
		fclose(nomfichier);
	}
	if(variable==4)
	{
		nomfichier=fopen("tableaux/niveau_gris_d.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&tableauniveaugris[i]);
		fclose(nomfichier);
	}

}

//-------------------------------------------------------------------------
//                               INITIALISE TABLEAU
//---------------------------------------------------------------------------
void initialise (char *entete, int M)
{
	int	i=0;
	for(i=0;i<M;i++)
		entete[i]='\0';
}

//-------------------------------------------------------------------------
//                             LISSAGE IMAGE
//---------------------------------------------------------------------------

void lissage(int *tableauniveaugris,int *tableaulissage,int largeur,int hauteur,int taillefichier,int tailleimage,int variable)
{
	int i,j;
	double lambda=8.0,ro=0.656765,omega=0.420432,epsilon=5758.175781;
	double b1=1.1991139,b2=-0.431341,k=0.232202;
	FILE *nomfichier;
	char *entete;
	unsigned char copie[2];


	// Filtrage suivant X
	for (i = 0; i<2; i++)
		for (j = 0; j<largeur; j++)
			tableaulissage[i*largeur+j]= tableauniveaugris[i*largeur+j]; 

	for(i=2; i<hauteur; i++)    
		for(j=0; j<largeur; j++)   
			tableaulissage[i*largeur+j]=(int)(k*tableauniveaugris[i*largeur+j]+b1*tableaulissage[(i-1)*largeur+j]+b2*tableaulissage[(i-2)*largeur+j]);
  
	for (i = 2; i<hauteur; i++)
		for (j = 0; j<largeur; j++)
			tableauniveaugris[i*largeur+j] = tableaulissage[i*largeur+j];
  // Filtrage non causal sur X
	for (i = hauteur-1; i>hauteur-3; i--)
		for (j = 0; j<largeur; j++)
			tableaulissage[i*largeur+j]= tableauniveaugris[i*largeur+j];

	for(i=hauteur-3; i>=0; i--)
		for(j=0; j<largeur; j++)
			tableaulissage[i*largeur+j] =(int)(k*tableauniveaugris[i*largeur+j]+b1*tableaulissage[(i+1)*largeur+j]+b2*tableaulissage[(i+2)*largeur+j]);

	for (i = 0; i<hauteur; i++)
		for (j = 0; j<largeur; j++)
			tableauniveaugris[i*largeur+j] = tableaulissage[i*largeur+j];

	// Filtrage suivant Y
	for (i = 0; i<hauteur; i++)
		for (j = 0; j<2; j++)
			tableaulissage[i*largeur+j]= tableauniveaugris[i*largeur+j]; 

	for(i=0; i<hauteur; i++)
		for(j=2; j<largeur; j++)   
			tableaulissage[i*largeur+j]=(int)(k*tableauniveaugris[i*largeur+j]+b1*tableaulissage[i*largeur+j-1]+b2*tableaulissage[i*largeur+j-2]); 

	for (i = 0; i<hauteur; i++)
		for (j = 0; j<largeur; j++)
			tableauniveaugris[i*largeur+j] = tableaulissage[i*largeur+j];

	// filtrage non causal sur Y
	for (i = 0; i<hauteur; i++)
		for (j = largeur-1; j>largeur-3; j--)
			tableaulissage[i*largeur+j]= tableauniveaugris[i*largeur+j]; 

	for(i=0; i<hauteur; i++)
		for(j=largeur-3; j>=0; j--)
			tableaulissage[i*largeur+j] =(int)(k*tableauniveaugris[i*largeur+j]+b1*tableaulissage[i*largeur+j+1]+b2*tableaulissage[i*largeur+j+2]);
  
	for (i = 0; i<hauteur; i++)
		for (j = 0; j<largeur; j++)
			tableauniveaugris[i*largeur+j] = tableaulissage[i*largeur+j];


	entete=(char *) malloc (sizeof(char)*(taillefichier-tailleimage));
   	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(entete,taillefichier-tailleimage);
	fread(entete,taillefichier-tailleimage,1,nomfichier);
	fclose(nomfichier);

	if(variable==1||variable==3)
		nomfichier=fopen("images_traitees/image_g_lissee.bmp","w");
	if(variable==2||variable==4)
		nomfichier=fopen("images_traitees/image_d_lissee.bmp","w");
	
	for(i=0;i<taillefichier-tailleimage;i++)
	{
		if(entete[i]==10)
			entete[i]=11;
		fprintf(nomfichier,"%c",entete[i]);
	}

	copie[1]='\0';

	if((largeur%4)==0)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableauniveaugris[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
			}
		}
	}

	if((largeur%4)==1)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableauniveaugris[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
			}
			fprintf(nomfichier,"%c",copie[1]);
		}
	}

	if((largeur%4)==2)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableauniveaugris[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
			}
			fprintf(nomfichier,"%c",copie[1]);
			fprintf(nomfichier,"%c",copie[1]);
		}
	}

	if((largeur%4)==3)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableauniveaugris[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
			}
			fprintf(nomfichier,"%c",copie[1]);
			fprintf(nomfichier,"%c",copie[1]);
			fprintf(nomfichier,"%c",copie[1]);
		}
	}
	fclose(nomfichier);
	free(entete);

}


//-------------------------------------------------------------------------
//                             DETECTION DE CONTOUR
//---------------------------------------------------------------------------

void trouvecontours(int *tableauniveaugris,int *tableaucontourfin,int largeur,int hauteur)
{
	int *gradient;
	int i,j;
	double threshold=0.01;
	int min=0,max=255;
	long int histocumule[256],histo;

	gradient=(int *) malloc (sizeof(int)*(largeur*hauteur));

	for(i=1;i<hauteur-1;i++)
		for(j=1;j<largeur-1;j++)
			gradient[i*largeur+j]=0; 

	for(i=1;i<hauteur-1;i++)
		for(j=1;j<largeur-1;j++)
			gradient[i*largeur+j]=-tableauniveaugris[i*largeur+j-1]-tableauniveaugris[i*largeur+j+1]+8*tableauniveaugris[i*largeur+j]-tableauniveaugris[(i-1)*largeur+j-1]-tableauniveaugris[(i-1)*largeur+j+1]-tableauniveaugris[(i-1)*largeur+j]-tableauniveaugris[(i+1)*largeur+j+1]-tableauniveaugris[(i+1)*largeur+j-1]-tableauniveaugris[(i+1)*largeur+j];

// fin laplacien ici

	for(i=1;i<hauteur-1;i++)
		for(j=1;j<largeur-1;j++)
		{
			if(gradient[i*largeur+j]>max)
				max=gradient[i*largeur+j];
			if(gradient[i*largeur+j]<min)
				min=gradient[i*largeur+j];
		}

	for(i=1;i<hauteur;i++)
		for(j=1;j<largeur;j++)
			tableaucontourfin[i*largeur+j]=gradient[i*largeur+j];

	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
 			tableaucontourfin[i*largeur+j]=255;

	for(i=1;i<hauteur-1;i++)
		for(j=1;j<largeur-1;j++)
			tableaucontourfin[i*largeur+j]=(255*(gradient[i*largeur+j]-min)/(max-min));

		//filtre moyenneur
	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
 			gradient[i*largeur+j]=tableaucontourfin[i*largeur+j];

	for(i=1;i<hauteur-1;i++)
		for(j=1;j<largeur-1;j++)
		{
			tableaucontourfin[i*largeur+j]=gradient[(i-1)*largeur+j]+gradient[(i-1)*largeur+j-1]+gradient[(i-1)*largeur+j+1]+gradient[(i+1)*largeur+j]+gradient[(i+1)*largeur+j-1]+gradient[(i+1)*largeur+j+1]+gradient[i*largeur+j]+gradient[i*largeur+j-1]+gradient[i*largeur+j+1];
			tableaucontourfin[i*largeur+j]=tableaucontourfin[i*largeur+j]/9;
		}

	for(i=1;i<hauteur;i++)
		for(j=1;j<largeur;j++)
			gradient[i*largeur+j]=tableaucontourfin[i*largeur+j];

	// Egalisation histogramme
	for(i=0;i!=256;i++)
		histocumule[i]=0;
	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
			histocumule[tableaucontourfin[i*largeur+j]]++;
	for(i=1;i!=256;i++)
		histocumule[i]=histocumule[i-1]+histocumule[i];
	for(i=0;i<(largeur*hauteur);i++)
	{
		histo=histocumule[tableaucontourfin[i]];
		tableaucontourfin[i]=(int)((histo*255)/(largeur*hauteur));
	}
}




//-------------------------------------------------------------------------
//                               CREER UNE IMAGE AVEC CONTOURS
//---------------------------------------------------------------------------

void imagecontour(int *tableaucontourfin,int largeur,int hauteur,int tailleimage,int taillefichier,int variable)
{
	int i,j;
	FILE *nomfichier;
	char *entete;
	unsigned char copie[2];

	entete=(char *) malloc (sizeof(char)*(taillefichier-tailleimage));
   	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(entete,taillefichier-tailleimage);
	fread(entete,taillefichier-tailleimage,1,nomfichier);
	fclose(nomfichier);

	if(variable==1||variable==3)
		nomfichier=fopen("images_traitees/image_g_contours_fins.bmp","w");

	if(variable==2||variable==4)
		nomfichier=fopen("images_traitees/image_d_contours_fins.bmp","w");
		
	for(i=0;i<taillefichier-tailleimage;i++)
	{
		if(entete[i]==10)
			entete[i]=11;
		fprintf(nomfichier,"%c",entete[i]);
	}

	copie[1]='\0';

	if((largeur%4)==0)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableaucontourfin[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
			}
		}
	}

	if((largeur%4)==1)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableaucontourfin[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
			}
			fprintf(nomfichier,"%c",copie[1]);
		}
	}

	if((largeur%4)==2)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableaucontourfin[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
			}
			fprintf(nomfichier,"%c",copie[1]);
			fprintf(nomfichier,"%c",copie[1]);
		}
	}

	if((largeur%4)==3)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableaucontourfin[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
			}
			fprintf(nomfichier,"%c",copie[1]);
			fprintf(nomfichier,"%c",copie[1]);
			fprintf(nomfichier,"%c",copie[1]);
		}
	}
	fclose(nomfichier);
	free(entete);
}

//-------------------------------------------------------------------------
//                               VALEUR ABSOLUE
//---------------------------------------------------------------------------
double absolue(int valeur)
{
	valeur=valeur*valeur;
	return sqrt(valeur);
}

 //-------------------------------------------------------------------------
 //                             ELARGISSEMENT DES CONTOURS DE L'IMAGE
 //---------------------------------------------------------------------------
void elargircontours(int *tableaucontourlarge,int *tableaucontourfin,int largeur,int hauteur,int taillefichier,int tailleimage,int variable)
{
	FILE *nomfichier;
	char *entete;
	unsigned char copie[2];
	int i,j;
	int gauche,droite,haut,bas,diff;
	int *interimaire;

	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
			tableaucontourlarge[i*largeur+j]=tableaucontourfin[i*largeur+j];

	for(i=1;i<hauteur-1;i++)
		for(j=4;j<largeur-4;j++)
		{	
			gauche=tableaucontourfin[i*largeur+j-3]+tableaucontourfin[i*largeur+j-2]+tableaucontourfin[i*largeur+j-1];
			droite=tableaucontourfin[i*largeur+j+3]+tableaucontourfin[i*largeur+j+2]+tableaucontourfin[i*largeur+j+1];
			diff=droite-gauche;
			if(diff<0)
				diff=-diff;
	
			if(diff>600)
				tableaucontourfin[i*largeur+j]=0;
			else
				tableaucontourfin[i*largeur+j]=255;
		}

	for(i=4;i<hauteur-4;i++)
		for(j=1;j<largeur-1;j++)
		{	
			haut=tableaucontourlarge[(i-3)*largeur+j]+tableaucontourlarge[(i-2)*largeur+j]+tableaucontourlarge[(i-1)*largeur+j];
			bas=tableaucontourlarge[(i+3)*largeur+j]+tableaucontourlarge[(i+2)*largeur+j]+tableaucontourlarge[(i+1)*largeur+j];
			diff=haut-bas;
			if(diff<0)
				diff=-diff;
			if(diff>600)
				tableaucontourfin[i*largeur+j]=0;
		}

	interimaire=(int *) malloc (sizeof(int)*(largeur*hauteur));
	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
			interimaire[i*largeur+j]=255;
	for(i=2;i<hauteur-2;i++)
		for(j=2;j<largeur-2;j++)
			if(tableaucontourfin[i*largeur+j]==0)
			{
				interimaire[i*largeur+j]=0;
				if((tableaucontourfin[(i-2)*largeur+j-2]==0)&&(tableaucontourfin[(i-1)*largeur+j-1]==255))
					interimaire[(i-1)*largeur+j-1]=0;
				if((tableaucontourfin[(i+2)*largeur+j-2]==0)&&(tableaucontourfin[(i+1)*largeur+j-1]==255))
					interimaire[(i+1)*largeur+j-1]=0;
				if((tableaucontourfin[(i-2)*largeur+j+2]==0)&&(tableaucontourfin[(i-1)*largeur+j+1]==255))
					interimaire[(i-1)*largeur+j+1]=0;
				if((tableaucontourfin[(i+2)*largeur+j+2]==0)&&(tableaucontourfin[(i+1)*largeur+j+1]==255))
					interimaire[(i+1)*largeur+j+1]=0;
			}
	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
			tableaucontourfin[i*largeur+j]=interimaire[i*largeur+j];
	free(interimaire);


	for(i=0;i<hauteur;i++)
	{
		for(j=1;j<largeur-1;j++)
		{	
			if((tableaucontourfin[i*largeur+j-1]==0)||(tableaucontourfin[i*largeur+j]==0)||(tableaucontourfin[i*largeur+j+1]==0))
				tableaucontourlarge[i*largeur+j]=0;
			else
				tableaucontourlarge[i*largeur+j]=255;
		}
	}


	if(variable==2)
	{

		for(i=0;i<hauteur;i++)
			for(j=0;j<largeur;j++)
				tableaucontourfin[i*largeur+j]=tableaucontourlarge[i*largeur+j];
		
			for(i=1;i<hauteur-1;i++)
			{
				for(j=0;j<largeur;j++)
				{	
					if((tableaucontourfin[(i-1)*largeur+j]==0)||(tableaucontourfin[i*largeur+j]==0)||(tableaucontourfin[(i+1)*largeur+j]==0))
						tableaucontourlarge[i*largeur+j]=0;
					else
						tableaucontourlarge[i*largeur+j]=255;
				}
			}

		for(i=0;i<hauteur;i++)
			for(j=0;j<largeur;j++)
				tableaucontourfin[i*largeur+j]=tableaucontourlarge[i*largeur+j];
		
			for(i=0;i<hauteur;i++)
			{
				for(j=1;j<largeur-1;j++)
				{	
					if((tableaucontourfin[i*largeur+j-1]==0)||(tableaucontourfin[i*largeur+j]==0)||(tableaucontourfin[i*largeur+j+1]==0))
						tableaucontourlarge[i*largeur+j]=0;
					else
						tableaucontourlarge[i*largeur+j]=255;
				}
			}	
	
	}

	if(variable==1)
	{

		for(i=0;i<hauteur;i++)
			for(j=0;j<largeur;j++)
				tableaucontourfin[i*largeur+j]=tableaucontourlarge[i*largeur+j];
		
			for(i=0;i<hauteur;i++)
			{
				for(j=1;j<largeur-1;j++)
				{	
					if((tableaucontourfin[i*largeur+j-1]==0)||(tableaucontourfin[i*largeur+j]==0)||(tableaucontourfin[i*largeur+j+1]==0))
						tableaucontourlarge[i*largeur+j]=0;
					else
						tableaucontourlarge[i*largeur+j]=255;
				}
			}

		for(i=0;i<hauteur;i++)
			for(j=0;j<largeur;j++)
				tableaucontourfin[i*largeur+j]=tableaucontourlarge[i*largeur+j];
		
			for(i=0;i<hauteur;i++)
			{
				for(j=1;j<largeur-1;j++)
				{	
					if((tableaucontourfin[i*largeur+j-1]==0)||(tableaucontourfin[i*largeur+j]==0)||(tableaucontourfin[i*largeur+j+1]==0))
						tableaucontourlarge[i*largeur+j]=0;
					else
						tableaucontourlarge[i*largeur+j]=255;
				}
			}	
	
	}

	entete=(char *) malloc (sizeof(char)*(taillefichier-tailleimage));
	nomfichier=fopen("images_originales/image_g.bmp","r");

	initialise(entete,taillefichier-tailleimage);
	fread(entete,taillefichier-tailleimage,1,nomfichier);
	fclose(nomfichier);

	if(variable==1)
	   	nomfichier=fopen("tableaux/image_g_contours_large.txt","w");
	if(variable==2)
	   	nomfichier=fopen("tableaux/image_d_contours_large.txt","w");
	if(variable==3)
	   	nomfichier=fopen("tableaux/image_g_contours_large2.txt","w");
	if(variable==4)
	   	nomfichier=fopen("tableaux/image_d_contours_large2.txt","w");

	for(i=0;i<largeur*hauteur;i++)
	{
		fprintf(nomfichier,"%d\n",tableaucontourlarge[i]);
	}
	fclose(nomfichier);


	if(variable==1)
		nomfichier=fopen("images_traitees/image_g_contour_large.bmp","w");
	if(variable==2)
		nomfichier=fopen("images_traitees/image_d_contour_large.bmp","w");
	if(variable==3)
		nomfichier=fopen("images_traitees/image_g_contour_large2.bmp","w");
	if(variable==4)
		nomfichier=fopen("images_traitees/image_d_contour_large2.bmp","w");
	
	for(i=0;i<taillefichier-tailleimage;i++)
	{
		fflush(stdin);
		if(entete[i]==10)
			entete[i]=11;
		fprintf(nomfichier,"%c",entete[i]);
	}

	copie[1]='\0';

	if((largeur%4)==0)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableaucontourlarge[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
			}
		}
	}

	if((largeur%4)==1)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableaucontourlarge[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
			}
				fprintf(nomfichier,"%c",copie[1]);
		}
	}

	if((largeur%4)==2)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableaucontourlarge[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
			}
				fprintf(nomfichier,"%c",copie[1]);
				fprintf(nomfichier,"%c",copie[1]);
		}
	}

	if((largeur%4)==3)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableaucontourlarge[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
			}
				fprintf(nomfichier,"%c",copie[1]);
				fprintf(nomfichier,"%c",copie[1]);
				fprintf(nomfichier,"%c",copie[1]);
		}
	}
	fclose(nomfichier);
	free(entete);
}


 //-------------------------------------------------------------------------
 //                             ELARGISSEMENT DES CONTOURS DE L'IMAGE
 //---------------------------------------------------------------------------
void elargircontours2(int *tableaucontourlarge,int *tableaucontourfin,int largeur,int hauteur,int taillefichier,int tailleimage,int variable,int *tableaucontourlarge2)
{
	FILE *nomfichier;
	char *entete;
	unsigned char copie[2];
	int i,j;
	int gauche,droite,haut,bas,diff;
	int *interimaire;

	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
			tableaucontourlarge[i*largeur+j]=tableaucontourfin[i*largeur+j];

	for(i=1;i<hauteur-1;i++)
		for(j=4;j<largeur-4;j++)
		{	
			gauche=tableaucontourfin[i*largeur+j-3]+tableaucontourfin[i*largeur+j-2]+tableaucontourfin[i*largeur+j-1];
			droite=tableaucontourfin[i*largeur+j+3]+tableaucontourfin[i*largeur+j+2]+tableaucontourfin[i*largeur+j+1];
			diff=droite-gauche;
			if(diff<0)
				diff=-diff;
	
			if(diff>600)
				tableaucontourfin[i*largeur+j]=0;
			else
				tableaucontourfin[i*largeur+j]=255;
		}

	for(i=4;i<hauteur-4;i++)
		for(j=1;j<largeur-1;j++)
		{	
			haut=tableaucontourlarge[(i-3)*largeur+j]+tableaucontourlarge[(i-2)*largeur+j]+tableaucontourlarge[(i-1)*largeur+j];
			bas=tableaucontourlarge[(i+3)*largeur+j]+tableaucontourlarge[(i+2)*largeur+j]+tableaucontourlarge[(i+1)*largeur+j];
			diff=haut-bas;
			if(diff<0)
				diff=-diff;
			if(diff>600)
				tableaucontourfin[i*largeur+j]=0;
		}

	interimaire=(int *) malloc (sizeof(int)*(largeur*hauteur));
	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
			interimaire[i*largeur+j]=255;
	for(i=2;i<hauteur-2;i++)
		for(j=2;j<largeur-2;j++)
			if(tableaucontourfin[i*largeur+j]==0)
			{
				interimaire[i*largeur+j]=0;
				if((tableaucontourfin[(i-2)*largeur+j-2]==0)&&(tableaucontourfin[(i-1)*largeur+j-1]==255))
					interimaire[(i-1)*largeur+j-1]=0;
				if((tableaucontourfin[(i+2)*largeur+j-2]==0)&&(tableaucontourfin[(i+1)*largeur+j-1]==255))
					interimaire[(i+1)*largeur+j-1]=0;
				if((tableaucontourfin[(i-2)*largeur+j+2]==0)&&(tableaucontourfin[(i-1)*largeur+j+1]==255))
					interimaire[(i-1)*largeur+j+1]=0;
				if((tableaucontourfin[(i+2)*largeur+j+2]==0)&&(tableaucontourfin[(i+1)*largeur+j+1]==255))
					interimaire[(i+1)*largeur+j+1]=0;
			}
	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
			tableaucontourfin[i*largeur+j]=interimaire[i*largeur+j];
	free(interimaire);


	for(i=0;i<hauteur;i++)
	{
		for(j=1;j<largeur-1;j++)
		{	
			if((tableaucontourfin[i*largeur+j-1]==0)||(tableaucontourfin[i*largeur+j]==0)||(tableaucontourfin[i*largeur+j+1]==0))
				tableaucontourlarge[i*largeur+j]=0;
			else
				tableaucontourlarge[i*largeur+j]=255;
		}
	}


	if(variable==2)
	{

		for(i=0;i<hauteur;i++)
			for(j=0;j<largeur;j++)
				tableaucontourfin[i*largeur+j]=tableaucontourlarge[i*largeur+j];
		
			for(i=1;i<hauteur-1;i++)
			{
				for(j=0;j<largeur;j++)
				{	
					if((tableaucontourfin[(i-1)*largeur+j]==0)||(tableaucontourfin[i*largeur+j]==0)||(tableaucontourfin[(i+1)*largeur+j]==0))
						tableaucontourlarge[i*largeur+j]=0;
					else
						tableaucontourlarge[i*largeur+j]=255;
				}
			}

		for(i=0;i<hauteur;i++)
			for(j=0;j<largeur;j++)
				tableaucontourfin[i*largeur+j]=tableaucontourlarge[i*largeur+j];
		
			for(i=0;i<hauteur;i++)
			{
				for(j=1;j<largeur-1;j++)
				{	
					if((tableaucontourfin[i*largeur+j-1]==0)||(tableaucontourfin[i*largeur+j]==0)||(tableaucontourfin[i*largeur+j+1]==0))
						tableaucontourlarge[i*largeur+j]=0;
					else
						tableaucontourlarge[i*largeur+j]=255;
				}
			}	
	
	}

	if(variable==1)
	{

		for(i=0;i<hauteur;i++)
			for(j=0;j<largeur;j++)
				tableaucontourfin[i*largeur+j]=tableaucontourlarge[i*largeur+j];
		
			for(i=0;i<hauteur;i++)
			{
				for(j=1;j<largeur-1;j++)
				{	
					if((tableaucontourfin[i*largeur+j-1]==0)||(tableaucontourfin[i*largeur+j]==0)||(tableaucontourfin[i*largeur+j+1]==0))
						tableaucontourlarge[i*largeur+j]=0;
					else
						tableaucontourlarge[i*largeur+j]=255;
				}
			}

		for(i=0;i<hauteur;i++)
			for(j=0;j<largeur;j++)
				tableaucontourfin[i*largeur+j]=tableaucontourlarge[i*largeur+j];
		
			for(i=0;i<hauteur;i++)
			{
				for(j=1;j<largeur-1;j++)
				{	
					if((tableaucontourfin[i*largeur+j-1]==0)||(tableaucontourfin[i*largeur+j]==0)||(tableaucontourfin[i*largeur+j+1]==0))
						tableaucontourlarge[i*largeur+j]=0;
					else
						tableaucontourlarge[i*largeur+j]=255;
				}
			}	
	
	}

	for(i=0;i<hauteur;i++)
	{
		for(j=0;j<largeur;j++)
		{	
			if(tableaucontourlarge2[i*largeur+j]==255)
				tableaucontourlarge[i*largeur+j]=255;
		}

	}

	entete=(char *) malloc (sizeof(char)*(taillefichier-tailleimage));
	nomfichier=fopen("images_originales/image_g.bmp","r");

	initialise(entete,taillefichier-tailleimage);
	fread(entete,taillefichier-tailleimage,1,nomfichier);
	fclose(nomfichier);

	if(variable==1)
	   	nomfichier=fopen("tableaux/image_g_contours_large.txt","w");
	if(variable==2)
	   	nomfichier=fopen("tableaux/image_d_contours_large.txt","w");
	if(variable==3)
	   	nomfichier=fopen("tableaux/image_g_contours_large2.txt","w");
	if(variable==4)
	   	nomfichier=fopen("tableaux/image_d_contours_large2.txt","w");

	for(i=0;i<largeur*hauteur;i++)
	{
		fprintf(nomfichier,"%d\n",tableaucontourlarge[i]);
	}
	fclose(nomfichier);


	if(variable==1)
		nomfichier=fopen("images_traitees/image_g_contour_large.bmp","w");
	if(variable==2)
		nomfichier=fopen("images_traitees/image_d_contour_large.bmp","w");
	if(variable==3)
		nomfichier=fopen("images_traitees/image_g_contour_large.bmp","w");
	if(variable==4)
		nomfichier=fopen("images_traitees/image_d_contour_large.bmp","w");
	
	for(i=0;i<taillefichier-tailleimage;i++)
	{
		fflush(stdin);
		if(entete[i]==10)
			entete[i]=11;
		fprintf(nomfichier,"%c",entete[i]);
	}

	copie[1]='\0';

	if((largeur%4)==0)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableaucontourlarge[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
			}
		}
	}

	if((largeur%4)==1)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableaucontourlarge[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
			}
				fprintf(nomfichier,"%c",copie[1]);
		}
	}

	if((largeur%4)==2)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableaucontourlarge[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
			}
				fprintf(nomfichier,"%c",copie[1]);
				fprintf(nomfichier,"%c",copie[1]);
		}
	}

	if((largeur%4)==3)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableaucontourlarge[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
				fflush(stdin);
				fprintf(nomfichier,"%c",copie[0]);
			}
				fprintf(nomfichier,"%c",copie[1]);
				fprintf(nomfichier,"%c",copie[1]);
				fprintf(nomfichier,"%c",copie[1]);
		}
	}
	fclose(nomfichier);
	free(entete);
}