// stereo.cpp : Defines the entry point for the console application.
//

//-------------------------------------------------------------------------
//				  PRESENTATION
//-------------------------------------------------------------------------
/* Ce programme a pour objectif de donner la disparit entre les pixels de l'image gauche et de l'image droite.
Pour ce faire, le programme fait une corrlation entre l'image gauche et l'image et on dtermine la correspondance des pixels en prenant la corrlation ayant la valeur la plus faible.
Il y a des tests pour vrifier que le rsultat trouv est crdible, sinon, la disparit est dtruite.
Pour gagner du temps dans le programme, on n'effectue des tests que sur les contours dtects de l'image.
On relance ensuite la corrlation mais cette fois de l'image droite sur l'image gauche et il faut que les 2 corrlations correspondent pour qu'on garde la disparit.*/


#include "stdafx.h"
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include<stdlib.h>
#include<process.h>
#include<dos.h>
#include<ctype.h>

void stereo(void);
int recdonneesimage(int);
void remplircouleurs(int *,int *,int *,int *,int *,int *,int *,int *,int *,int,int);
void initialise (char *,int);
void zoneatraiter(int *,int,int);
void correlation(int *,int *,int *,int *,int *,int *,int *,int *,int *,int *,int,int);
int carre(int);
void imagefinale(int *,int *,int,int,int,int);


//-------------------------------------------------------------------------
//				  M A I N
//-------------------------------------------------------------------------
void main (void)
{	
	stereo();
}

//-------------------------------------------------------------------------
//                               STEREOVISION
//---------------------------------------------------------------------------
void stereo (void)
{
	int largeur,hauteur,taillefichier,tailleimage,taille;
	int *contour_g,*contour_d;
	int *tableauR,*tableauG,*tableauB,*tableauRd,*tableauGd,*tableauBd,*tableau_gris;
	int *tableaucorr;

	largeur=recdonneesimage(0);
	hauteur=recdonneesimage(1);
	taillefichier=recdonneesimage(2);
	tailleimage=recdonneesimage(3);
	taille=largeur*hauteur;

	contour_g=(int *) malloc (sizeof(int)*(largeur*hauteur));
	contour_d=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauR=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauRd=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauG=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauGd=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauB=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauBd=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableau_gris=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableaucorr=(int *) malloc (sizeof(int)*(largeur*hauteur));
	remplircouleurs(contour_g,contour_d,tableauR,tableauRd,tableauG,tableauGd,tableauB,tableauBd,tableau_gris,taille,0);

	printf("                       ETAPE 4\n");
	printf("        Trouver les correspondances\n\n");
	zoneatraiter(contour_g,largeur,hauteur);
	printf("correlation des 2 images\n");
	correlation(tableaucorr,contour_g,contour_d,tableauR,tableauG,tableauB,tableauRd,tableauGd,tableauBd,tableau_gris,largeur,hauteur);
	printf("\n        Creation de l'image finale\n");
	imagefinale(tableaucorr,tableau_gris,largeur,hauteur,taillefichier,tailleimage);
	free(contour_g);
	free(contour_d);
	free(tableauR);
	free(tableauRd);
	free(tableauG);
	free(tableauGd);
	free(tableauB);
	free(tableauBd);
	free(tableau_gris);
	free(tableaucorr);
	printf("Fin Partie 4 \n\n");
//	getch();
}

//-------------------------------------------------------------------------
//                               RECUPERATION DES DONNEES DU FICHIER
//---------------------------------------------------------------------------
// Cette fonction permet de rcuprer des donnes sur les images,  savoir la largeur, hauteur, taille totale du fichier et taille totale de l'image.
int recdonneesimage(int variable)
{
	FILE *nomfichier;
	int taillefichier,tailleimage,largeur,hauteur;

	nomfichier=fopen("donnees_images/description.txt","r");
	fscanf(nomfichier,"%d",&taillefichier);
	fscanf(nomfichier,"%d",&tailleimage);
	fscanf(nomfichier,"%d",&largeur);
	fscanf(nomfichier,"%d",&hauteur);
	fclose(nomfichier);
	if(variable==0)
		return largeur;
	if(variable==1)
		return hauteur;
	if(variable==2)
		return taillefichier;
	if(variable==3)
		return tailleimage;
	else
		return -1;
}

//-------------------------------------------------------------------------
//                               RECUPERATION DES COULEURS
//---------------------------------------------------------------------------
// Cette fontion s'occupe de rcuprer les couleurs des 2 images pour les mettre en mmoire
void remplircouleurs(int *contour_g,int *contour_d,int *tableauR,int *tableauRd,int *tableauG,int *tableauGd,int *tableauB,int *tableauBd,int *tableau_gris,int taille,int variable)
{
	FILE *nomfichier;
	int i;

		nomfichier=fopen("tableaux/image_g_contours_large.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&contour_g[i]);
		fclose(nomfichier);
		
		nomfichier=fopen("tableaux/image_d_contours_large.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&contour_d[i]);
		fclose(nomfichier);

		nomfichier=fopen("tableaux/couleurRg_egalisee.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&tableauR[i]);
		fclose(nomfichier);

		nomfichier=fopen("tableaux/couleurRd_egalisee.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&tableauRd[i]);
		fclose(nomfichier);

		nomfichier=fopen("tableaux/couleurGg_egalisee.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&tableauG[i]);
		fclose(nomfichier);

		nomfichier=fopen("tableaux/couleurGd_egalisee.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&tableauGd[i]);
		fclose(nomfichier);

		nomfichier=fopen("tableaux/couleurBg_egalisee.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&tableauB[i]);
		fclose(nomfichier);

		nomfichier=fopen("tableaux/couleurBd_egalisee.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&tableauBd[i]);
		fclose(nomfichier);

		nomfichier=fopen("tableaux/niveau_gris_g.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&tableau_gris[i]);
		fclose(nomfichier);
}

//-------------------------------------------------------------------------
//                               INITIALISE TABLEAU
//---------------------------------------------------------------------------
// cette fonction initialise un tableau avec que des 0
void initialise (char *entete, int M)
{
	int	i=0;
	for(i=0;i<M;i++)
		entete[i]='\0';
}

//-------------------------------------------------------------------------
//                             DETERMINATION DES ZONES A TRAITER
//---------------------------------------------------------------------------
// Cette fonction sert  exclure des zones de l'image qu'il ne faut pas traiter.
// En effet, la fentre de corrlation fait 5*5, donc il faut exclure 2 pixels sur les cts
void zoneatraiter(int *contour_g,int largeur,int hauteur)
{
	int i,j;
	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
		{	
			if((j<2)||(i<2)||(j>largeur-3)||(i>hauteur-3))
				contour_g[i*largeur+j]=255;
		}
}

//-------------------------------------------------------------------------
//                             CORRELATION DES IMAGES
//---------------------------------------------------------------------------
// Mthode pour trouver la disparit des points de contour
void correlation(int *tableaucorr,int *contour_g,int *contour_d,int *tableauR,int *tableauG,int *tableauB,int *tableauRd,int *tableauGd,int *tableauBd,int *tableau_gris,int largeur,int hauteur)
{
	int differenceR,differenceG,differenceB;
	int differenceRtotal=0,differenceGtotal=0,differenceBtotal=0;
	int difference=0,difference2,difference3,*attention,*attention2;
	int i,j,k;
	int position, seuil,distance;

	attention=(int *) malloc (sizeof(int)*(largeur*hauteur));
	attention2=(int *) malloc (sizeof(int)*(largeur*hauteur));
	for(i=2;i<hauteur-2;i++)
		for(j=2;j<largeur-2;j++)
			attention[i*largeur+j]=1;

	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
			tableaucorr[i*largeur+j]=0;

	seuil=500000;

	for(i=0;i<hauteur;i++)
	{
		for(j=0;j<largeur;j++)
		{	
			if(contour_g[i*largeur+j]==0)	// si on trouve un contour
			{
				position=0;
				difference2=-1;

				for(k=0;k<largeur;k++)
				{	
					if(contour_d[i*largeur+k]==0)
					{
						differenceRtotal=0;
						differenceGtotal=0;
						differenceBtotal=0;

						differenceR=carre((tableauR[i*largeur+j-1]-tableauR[i*largeur+j])-(tableauRd[i*largeur+k-1]-tableauRd[i*largeur+k]));
						differenceG=((tableauG[i*largeur+j-1]-tableauG[i*largeur+j])-(tableauGd[i*largeur+k-1]-tableauGd[i*largeur+k]))*((tableauG[i*largeur+j-1]-tableauG[i*largeur+j])-(tableauGd[i*largeur+k-1]-tableauGd[i*largeur+k]));
						differenceB=((tableauB[i*largeur+j-1]-tableauB[i*largeur+j])-(tableauBd[i*largeur+k-1]-tableauBd[i*largeur+k]))*((tableauB[i*largeur+j-1]-tableauB[i*largeur+j])-(tableauBd[i*largeur+k-1]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;

						differenceR=((tableauR[i*largeur+j+1]-tableauR[i*largeur+j])-(tableauRd[i*largeur+k+1]-tableauRd[i*largeur+k]))*((tableauR[i*largeur+j+1]-tableauR[i*largeur+j])-(tableauRd[i*largeur+k+1]-tableauRd[i*largeur+k]));
						differenceG=((tableauG[i*largeur+j+1]-tableauG[i*largeur+j])-(tableauGd[i*largeur+k+1]-tableauGd[i*largeur+k]))*((tableauG[i*largeur+j+1]-tableauG[i*largeur+j])-(tableauGd[i*largeur+k+1]-tableauGd[i*largeur+k]));
						differenceB=((tableauB[i*largeur+j+1]-tableauB[i*largeur+j])-(tableauBd[i*largeur+k+1]-tableauBd[i*largeur+k]))*((tableauB[i*largeur+j+1]-tableauB[i*largeur+j])-(tableauBd[i*largeur+k+1]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;					
					
						differenceR=((tableauR[i*(largeur+1)+j]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+1)+k]-tableauRd[i*largeur+k]))*((tableauR[i*(largeur+1)+j]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+1)+k]-tableauRd[i*largeur+k]));
						differenceG=((tableauG[i*(largeur+1)+j]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+1)+k]-tableauGd[i*largeur+k]))*((tableauG[i*(largeur+1)+j]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+1)+k]-tableauGd[i*largeur+k]));
						differenceB=((tableauB[i*(largeur+1)+j]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+1)+k]-tableauBd[i*largeur+k]))*((tableauB[i*(largeur+1)+j]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+1)+k]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	
					
						differenceR=((tableauR[i*(largeur-1)+j]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-1)+k]-tableauRd[i*largeur+k]))*((tableauR[i*(largeur-1)+j]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-1)+k]-tableauRd[i*largeur+k]));
						differenceG=((tableauG[i*(largeur-1)+j]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-1)+k]-tableauGd[i*largeur+k]))*((tableauG[i*(largeur-1)+j]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-1)+k]-tableauGd[i*largeur+k]));
						differenceB=((tableauB[i*(largeur-1)+j]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-1)+k]-tableauBd[i*largeur+k]))*((tableauB[i*(largeur-1)+j]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-1)+k]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	
					
						differenceR=((tableauR[i*(largeur-1)+j-1]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-1)+k-1]-tableauRd[i*largeur+k]))*((tableauR[i*(largeur-1)+j-1]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-1)+k-1]-tableauRd[i*largeur+k]));
						differenceG=((tableauG[i*(largeur-1)+j-1]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-1)+k-1]-tableauGd[i*largeur+k]))*((tableauG[i*(largeur-1)+j-1]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-1)+k-1]-tableauGd[i*largeur+k]));
						differenceB=((tableauB[i*(largeur-1)+j-1]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-1)+k-1]-tableauBd[i*largeur+k]))*((tableauB[i*(largeur-1)+j-1]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-1)+k-1]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	
					
						differenceR=((tableauR[i*(largeur-1)+j+1]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-1)+k+1]-tableauRd[i*largeur+k]))*((tableauR[i*(largeur-1)+j+1]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-1)+k+1]-tableauRd[i*largeur+k]));
						differenceG=((tableauG[i*(largeur-1)+j+1]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-1)+k+1]-tableauGd[i*largeur+k]))*((tableauG[i*(largeur-1)+j+1]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-1)+k+1]-tableauGd[i*largeur+k]));
						differenceB=((tableauB[i*(largeur-1)+j+1]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-1)+k+1]-tableauBd[i*largeur+k]))*((tableauB[i*(largeur-1)+j+1]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-1)+k+1]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=((tableauR[i*(largeur+1)+j-1]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+1)+k-1]-tableauRd[i*largeur+k]))*((tableauR[i*(largeur+1)+j-1]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+1)+k-1]-tableauRd[i*largeur+k]));
						differenceG=((tableauG[i*(largeur+1)+j-1]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+1)+k-1]-tableauGd[i*largeur+k]))*((tableauG[i*(largeur+1)+j-1]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+1)+k-1]-tableauGd[i*largeur+k]));
						differenceB=((tableauB[i*(largeur+1)+j-1]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+1)+k-1]-tableauBd[i*largeur+k]))*((tableauB[i*(largeur+1)+j-1]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+1)+k-1]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;						
					
						differenceR=((tableauR[i*(largeur+1)+j+1]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+1)+k+1]-tableauRd[i*largeur+k]))*((tableauR[i*(largeur+1)+j+1]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+1)+k-1]-tableauRd[i*largeur+k]));
						differenceG=((tableauG[i*(largeur+1)+j+1]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+1)+k+1]-tableauGd[i*largeur+k]))*((tableauG[i*(largeur+1)+j+1]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+1)+k-1]-tableauGd[i*largeur+k]));
						differenceB=((tableauB[i*(largeur+1)+j+1]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+1)+k+1]-tableauBd[i*largeur+k]))*((tableauB[i*(largeur+1)+j+1]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+1)+k-1]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur-2)+j-2]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-2)+k-2]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur-2)+j-2]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-2)+k-2]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur-2)+j-2]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-2)+k-2]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur-1)+j-2]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-1)+k-2]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur-1)+j-2]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-1)+k-2]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur-1)+j-2]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-1)+k-2]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur)+j-2]-tableauR[i*largeur+j])-(tableauRd[i*(largeur)+k-2]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur)+j-2]-tableauG[i*largeur+j])-(tableauGd[i*(largeur)+k-2]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur)+j-2]-tableauB[i*largeur+j])-(tableauBd[i*(largeur)+k-2]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur+1)+j-2]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+1)+k-2]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur+1)+j-2]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+1)+k-2]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur+1)+j-2]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+1)+k-2]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur+2)+j-2]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+2)+k-2]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur+2)+j-2]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+2)+k-2]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur+2)+j-2]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+2)+k-2]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur-2)+j+2]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-2)+k+2]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur-2)+j+2]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-2)+k+2]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur-2)+j+2]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-2)+k+2]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur-1)+j+2]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-1)+k+2]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur-1)+j+2]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-1)+k+2]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur-1)+j+2]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-1)+k+2]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur)+j+2]-tableauR[i*largeur+j])-(tableauRd[i*(largeur)+k+2]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur)+j+2]-tableauG[i*largeur+j])-(tableauGd[i*(largeur)+k+2]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur)+j+2]-tableauB[i*largeur+j])-(tableauBd[i*(largeur)+k+2]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur+1)+j+2]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+1)+k+2]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur+1)+j+2]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+1)+k+2]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur+1)+j+2]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+1)+k+2]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur+2)+j+2]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+2)+k+2]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur+2)+j+2]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+2)+k+2]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur+2)+j+2]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+2)+k+2]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur+2)+j-1]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+2)+k-1]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur+2)+j-1]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+2)+k-1]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur+2)+j-1]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+2)+k-1]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur+2)+j+1]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+2)+k+1]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur+2)+j+1]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+2)+k+1]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur+2)+j+1]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+2)+k+1]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur+2)+j]-tableauR[i*largeur+j])-(tableauRd[i*(largeur+2)+k]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur+2)+j]-tableauG[i*largeur+j])-(tableauGd[i*(largeur+2)+k]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur+2)+j]-tableauB[i*largeur+j])-(tableauBd[i*(largeur+2)+k]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur-2)+j-1]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-2)+k-1]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur-2)+j-1]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-2)+k-1]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur-2)+j-1]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-2)+k-1]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur-2)+j+1]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-2)+k+1]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur-2)+j+1]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-2)+k+1]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur-2)+j+1]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-2)+k+1]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						differenceR=carre((tableauR[i*(largeur-2)+j]-tableauR[i*largeur+j])-(tableauRd[i*(largeur-2)+k]-tableauRd[i*largeur+k]));
						differenceG=carre((tableauG[i*(largeur-2)+j]-tableauG[i*largeur+j])-(tableauGd[i*(largeur-2)+k]-tableauGd[i*largeur+k]));
						differenceB=carre((tableauB[i*(largeur-2)+j]-tableauB[i*largeur+j])-(tableauBd[i*(largeur-2)+k]-tableauBd[i*largeur+k]));
						differenceRtotal=differenceRtotal+differenceR;
						differenceGtotal=differenceGtotal+differenceG;
						differenceBtotal=differenceBtotal+differenceB;	

						// on calcul l'ensemble des diffrence entre les 2 images

						difference=differenceRtotal+differenceBtotal+differenceGtotal;
						if(difference2==-1)
							difference2=difference;	// au premier pixel, on initialise la variable diffrence
						if(difference==difference2)
							attention[i*largeur+j]=1;	// en cas d'galit entre 2 pixels, il faut faire attention
						if(difference<difference2)
						{
							position=k;					// on note la position du meilleurs pixel
							difference2=difference;
							attention[i*largeur+j]=0;
							difference3=carre(tableauR[i*largeur+j]-tableauRd[i*largeur+k])+carre(tableauG[i*largeur+j]-tableauGd[i*largeur+k])+carre(tableauB[i*largeur+j]-tableauBd[i*largeur+k]);
						}
					}
				}
				tableaucorr[i*largeur+j]=j-position;
				if(tableaucorr[i*largeur+j]<0)			// on effectue quelques vrifications pour enlever les mesures abrantes
					tableaucorr[i*largeur+j]=0;
				if(tableaucorr[i*largeur+j]>largeur)
					tableaucorr[i*largeur+j]=0;
				if(difference2>seuil)
					tableaucorr[i*largeur+j]=0;
				if(difference3>700)
					tableaucorr[i*largeur+j]=0;			
			}
		}
		if(i%25==0)
			printf("ligne = %d/%d\n",i,hauteur);
	}

	printf("\nVerification des resultats\n");

	// On effectue les mmes calculs, mais en partant des pixels de l'image droite
	for(i=0;i<hauteur;i++)
	{
		for(j=0;j<largeur;j++)
		{	
			if(tableaucorr[i*largeur+j]!=0)
			{
				position=0;
				difference2=-1;
				distance=tableaucorr[i*largeur+j];

				for(k=0;k<largeur;k++)
				{	
					differenceRtotal=0;
					differenceGtotal=0;
					differenceBtotal=0;

					differenceR=carre((tableauR[i*largeur+k-1]-tableauR[i*largeur+k])-(tableauRd[i*largeur+j-1-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=((tableauG[i*largeur+k-1]-tableauG[i*largeur+k])-(tableauGd[i*largeur+j-1-distance]-tableauGd[i*largeur+j-distance]))*((tableauG[i*largeur+k-1]-tableauG[i*largeur+k])-(tableauGd[i*largeur+j-1-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=((tableauB[i*largeur+k-1]-tableauB[i*largeur+k])-(tableauBd[i*largeur+j-1-distance]-tableauBd[i*largeur+j-distance]))*((tableauB[i*largeur+k-1]-tableauB[i*largeur+k])-(tableauBd[i*largeur+j-1-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;

					differenceR=((tableauR[i*largeur+k+1]-tableauR[i*largeur+k])-(tableauRd[i*largeur+j+1-distance]-tableauRd[i*largeur+j-distance]))*((tableauR[i*largeur+k+1]-tableauR[i*largeur+k])-(tableauRd[i*largeur+j+1-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=((tableauG[i*largeur+k+1]-tableauG[i*largeur+k])-(tableauGd[i*largeur+j+1-distance]-tableauGd[i*largeur+j-distance]))*((tableauG[i*largeur+k+1]-tableauG[i*largeur+k])-(tableauGd[i*largeur+j+1-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=((tableauB[i*largeur+k+1]-tableauB[i*largeur+k])-(tableauBd[i*largeur+j+1-distance]-tableauBd[i*largeur+j-distance]))*((tableauB[i*largeur+k+1]-tableauB[i*largeur+k])-(tableauBd[i*largeur+j+1-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;					
					
					differenceR=((tableauR[i*(largeur+1)+k]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+1)+j-distance]-tableauRd[i*largeur+j-distance]))*((tableauR[i*(largeur+1)+k]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+1)+j-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=((tableauG[i*(largeur+1)+k]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+1)+j-distance]-tableauGd[i*largeur+j-distance]))*((tableauG[i*(largeur+1)+k]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+1)+j-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=((tableauB[i*(largeur+1)+k]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+1)+j-distance]-tableauBd[i*largeur+j-distance]))*((tableauB[i*(largeur+1)+k]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+1)+j-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	
					
					differenceR=((tableauR[i*(largeur-1)+k]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-1)+j-distance]-tableauRd[i*largeur+j-distance]))*((tableauR[i*(largeur-1)+k]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-1)+j-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=((tableauG[i*(largeur-1)+k]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-1)+j-distance]-tableauGd[i*largeur+j-distance]))*((tableauG[i*(largeur-1)+k]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-1)+j-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=((tableauB[i*(largeur-1)+k]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-1)+j-distance]-tableauBd[i*largeur+j-distance]))*((tableauB[i*(largeur-1)+k]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-1)+j-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	
					
					differenceR=((tableauR[i*(largeur-1)+k-1]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-1)+j-1-distance]-tableauRd[i*largeur+j-distance]))*((tableauR[i*(largeur-1)+k-1]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-1)+j-1-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=((tableauG[i*(largeur-1)+k-1]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-1)+j-1-distance]-tableauGd[i*largeur+j-distance]))*((tableauG[i*(largeur-1)+k-1]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-1)+j-1-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=((tableauB[i*(largeur-1)+k-1]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-1)+j-1-distance]-tableauBd[i*largeur+j-distance]))*((tableauB[i*(largeur-1)+k-1]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-1)+j-1-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	
					
					differenceR=((tableauR[i*(largeur-1)+k+1]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-1)+j+1-distance]-tableauRd[i*largeur+j-distance]))*((tableauR[i*(largeur-1)+k+1]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-1)+j+1-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=((tableauG[i*(largeur-1)+k+1]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-1)+j+1-distance]-tableauGd[i*largeur+j-distance]))*((tableauG[i*(largeur-1)+k+1]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-1)+j+1-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=((tableauB[i*(largeur-1)+k+1]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-1)+j+1-distance]-tableauBd[i*largeur+j-distance]))*((tableauB[i*(largeur-1)+k+1]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-1)+j+1-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=((tableauR[i*(largeur+1)+k-1]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+1)+j-1-distance]-tableauRd[i*largeur+j-distance]))*((tableauR[i*(largeur+1)+k-1]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+1)+j-1-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=((tableauG[i*(largeur+1)+k-1]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+1)+j-1-distance]-tableauGd[i*largeur+j-distance]))*((tableauG[i*(largeur+1)+k-1]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+1)+j-1-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=((tableauB[i*(largeur+1)+k-1]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+1)+j-1-distance]-tableauBd[i*largeur+j-distance]))*((tableauB[i*(largeur+1)+k-1]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+1)+j-1-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;						
					
					differenceR=((tableauR[i*(largeur+1)+k+1]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+1)+j+1-distance]-tableauRd[i*largeur+j-distance]))*((tableauR[i*(largeur+1)+k+1]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+1)+j-1-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=((tableauG[i*(largeur+1)+k+1]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+1)+j+1-distance]-tableauGd[i*largeur+j-distance]))*((tableauG[i*(largeur+1)+k+1]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+1)+j-1-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=((tableauB[i*(largeur+1)+k+1]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+1)+j+1-distance]-tableauBd[i*largeur+j-distance]))*((tableauB[i*(largeur+1)+k+1]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+1)+j-1-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur-2)+k-2]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-2)+j-2-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur-2)+k-2]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-2)+j-2-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur-2)+k-2]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-2)+j-2-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur-1)+k-2]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-1)+j-2-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur-1)+k-2]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-1)+j-2-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur-1)+k-2]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-1)+j-2-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur)+k-2]-tableauR[i*largeur+k])-(tableauRd[i*(largeur)+j-2-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur)+k-2]-tableauG[i*largeur+k])-(tableauGd[i*(largeur)+j-2-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur)+k-2]-tableauB[i*largeur+k])-(tableauBd[i*(largeur)+j-2-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur+1)+k-2]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+1)+j-2-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur+1)+k-2]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+1)+j-2-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur+1)+k-2]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+1)+j-2-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur+2)+k-2]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+2)+j-2-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur+2)+k-2]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+2)+j-2-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur+2)+k-2]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+2)+j-2-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur-2)+k+2]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-2)+j+2-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur-2)+k+2]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-2)+j+2-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur-2)+k+2]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-2)+j+2-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur-1)+k+2]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-1)+j+2-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur-1)+k+2]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-1)+j+2-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur-1)+k+2]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-1)+j+2-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur)+k+2]-tableauR[i*largeur+k])-(tableauRd[i*(largeur)+j+2-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur)+k+2]-tableauG[i*largeur+k])-(tableauGd[i*(largeur)+j+2-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur)+k+2]-tableauB[i*largeur+k])-(tableauBd[i*(largeur)+j+2-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur+1)+k+2]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+1)+j+2-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur+1)+k+2]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+1)+j+2-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur+1)+k+2]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+1)+j+2-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur+2)+k+2]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+2)+j+2-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur+2)+k+2]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+2)+j+2-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur+2)+k+2]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+2)+j+2-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur+2)+k-1]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+2)+j-1-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur+2)+k-1]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+2)+j-1-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur+2)+k-1]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+2)+j-1-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur+2)+k+1]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+2)+j+1-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur+2)+k+1]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+2)+j+1-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur+2)+k+1]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+2)+j+1-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur+2)+k]-tableauR[i*largeur+k])-(tableauRd[i*(largeur+2)+j-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur+2)+k]-tableauG[i*largeur+k])-(tableauGd[i*(largeur+2)+j-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur+2)+k]-tableauB[i*largeur+k])-(tableauBd[i*(largeur+2)+j-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur-2)+k-1]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-2)+j-1-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur-2)+k-1]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-2)+j-1-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur-2)+k-1]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-2)+j-1-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur-2)+k+1]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-2)+j+1-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur-2)+k+1]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-2)+j+1-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur-2)+k+1]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-2)+j+1-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					differenceR=carre((tableauR[i*(largeur-2)+k]-tableauR[i*largeur+k])-(tableauRd[i*(largeur-2)+j-distance]-tableauRd[i*largeur+j-distance]));
					differenceG=carre((tableauG[i*(largeur-2)+k]-tableauG[i*largeur+k])-(tableauGd[i*(largeur-2)+j-distance]-tableauGd[i*largeur+j-distance]));
					differenceB=carre((tableauB[i*(largeur-2)+k]-tableauB[i*largeur+k])-(tableauBd[i*(largeur-2)+j-distance]-tableauBd[i*largeur+j-distance]));
					differenceRtotal=differenceRtotal+differenceR;
					differenceGtotal=differenceGtotal+differenceG;
					differenceBtotal=differenceBtotal+differenceB;	

					difference=differenceRtotal+differenceBtotal+differenceGtotal;


					if(difference2==-1)
						difference2=difference;
					if(difference==difference2)
						attention2[i*largeur+j]=1;
					if(difference<difference2)
					{
						position=k;
						difference2=difference;
						attention2[i*largeur+j]=0;
					}
				}
				if(!((j-position<5)&&(j-position>-5)))
					tableaucorr[i*largeur+j]=0;
			}
		}
		if(i%25==0)
			printf("ligne = %d/%d\n",i,hauteur);
	}

}



 //-------------------------------------------------------------------------
 //                               AU CARRE
 //---------------------------------------------------------------------------
// Cette fonction renvoi une valeur mise au carr

int carre(int valeur)
{
	return valeur*valeur;
}

 //-------------------------------------------------------------------------
 //                             CREATION DE L'IMAGE FINALE
 //---------------------------------------------------------------------------
// Cette fonction se charge de raliser l'image montrant la disparit des contours.

void imagefinale(int *tableaucorr,int *tableau_gris,int largeur,int hauteur,int taillefichier,int tailleimage)
{
	FILE *nomfichier;
	char *entete;
	unsigned char copie[2],copie2[2],copiecouleur[2];
	int i,j;
	int max=0,min,i2=0,j2=0,bin;
	float pas;
	int *histocumule,maxhisto=0;

	histocumule=(int *) malloc (sizeof(int)*(largeur));
	for(i=0;i<largeur;i++)
		histocumule[i]=0;
	for(i=0;i<largeur*hauteur;i++)
		histocumule[tableaucorr[i]]++;
	histocumule[0]=0;
	for(i=0;i<largeur-1;i++)
		if(histocumule[i]>maxhisto)
			maxhisto=histocumule[i];
	for(i=1;i<largeur;i++)
		if(histocumule[i]<(maxhisto/20))
			histocumule[i]=0;
/*	for(i=0;i<largeur*hauteur;i++)
		if(histocumule[tableaucorr[i]]==0)
			tableaucorr[i]=0;*/
	for(i=0;i<largeur;i++)
		histocumule[i]=0;
	for(i=0;i<largeur*hauteur;i++)
		histocumule[tableaucorr[i]]++;
	for(i=10;i<largeur-11;i++)
		if((histocumule[i-10]==0)&&(histocumule[i-9]==0)&&(histocumule[i-8]==0)&&(histocumule[i-7]==0)&&(histocumule[i-6]==0)&&(histocumule[i-5]==0)&&(histocumule[i-4]==0)&&(histocumule[i-3]==0)&&(histocumule[i-2]==0)&&(histocumule[i-1]==0)&&(histocumule[i+1]==0)&&(histocumule[i+2]==0)&&(histocumule[i+3]==0)&&(histocumule[i+4]==0)&&(histocumule[i+5]==0)&&(histocumule[i+6]==0)&&(histocumule[i+7]==0)&&(histocumule[i+8]==0)&&(histocumule[i+9]==0)&&(histocumule[i+10]==0)&&(histocumule[i]<maxhisto/5))
			histocumule[i]=0;
	for(i=0;i<largeur*hauteur;i++)
		if(histocumule[tableaucorr[i]]==0)
			tableaucorr[i]=0;	
	for(i=0;i<largeur;i++)
		histocumule[i]=0;
	for(i=0;i<largeur*hauteur;i++)
		histocumule[tableaucorr[i]]++;
/*	nomfichier=fopen("tableaux/histo_disparite.txt","w");
	for(i=0;i<largeur;i++)
	{
		fprintf(nomfichier,"%d : %d\n",i,histocumule[i]);
	}
	fclose(nomfichier);*/


	nomfichier=fopen("tableaux/image_g_contours_large2.txt","r");
	for(i=0;i<hauteur;i++)
	{
		for(j=0;j<largeur;j++)
		{
			fscanf(nomfichier,"%d",&bin);
			if(bin==255&&tableaucorr[i*largeur+j]!=0)
				tableaucorr[i*largeur+j]=0;
		}
	}
	fclose(nomfichier);


	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
		{	
			if(tableaucorr[i*largeur+j]>max)
				max=tableaucorr[i*largeur+j];
			if(tableaucorr[i*largeur+j]>largeur)
				printf("bug\n");
		}
	printf("max = %d\n",max);
	
	min=max;
	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
			if(tableaucorr[i*largeur+j]<min&&tableaucorr[i*largeur+j]!=0)
				min=tableaucorr[i*largeur+j];
	printf("min = %d\n",min);
	
	nomfichier=fopen("tableaux/disparite.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		fprintf(nomfichier,"%d\n",tableaucorr[i]);
	}
	fclose(nomfichier);

	pas=(float)(max-min+1);
	pas=760/pas;
	
	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
			if(tableaucorr[i*largeur+j]!=0)
				tableaucorr[i*largeur+j]=(int)((tableaucorr[i*largeur+j]-min+1)*pas);


	entete=(char *) malloc (sizeof(char)*(taillefichier-tailleimage));
   	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(entete,taillefichier-tailleimage);
	fread(entete,taillefichier-tailleimage,1,nomfichier);
	fclose(nomfichier);
	
	nomfichier=fopen("images_traitees/image_disparite_traitee.bmp","w");
	for(i=0;i<taillefichier-tailleimage;i++)
	{
		if(entete[i]==10)
			entete[i]=11;
		fprintf(nomfichier,"%c",entete[i]);
	}

	copie[1]='\0';
	copie2[1]='\0';
	copiecouleur[1]='\0';

	if((largeur%4)==0)
	{	
		for(i=0;i<hauteur;i++)
			{
				for(j=0;j<largeur;j++)
				{
					if(tableaucorr[i*largeur+j]==0)
					{
						fprintf(nomfichier,"%c",255);
						fprintf(nomfichier,"%c",255);
						fprintf(nomfichier,"%c",255);
					}
					else
					{
						copie[0]=tableaucorr[i*largeur+j];
						if(copie[0]==10)
							copie[0]=11;
						fprintf(nomfichier,"%c",0);
						fprintf(nomfichier,"%c",0);
						fprintf(nomfichier,"%c",0);
					}
				}
			}
	}

	if((largeur%4)==1)
	{	
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(tableaucorr[i*largeur+j]==0)
				{
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
				}
				else
				{
					copie[0]=tableaucorr[i*largeur+j];
					if(copie[0]==10)
						copie[0]=11;
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
				}
			}
				fprintf(nomfichier,"%c",255);
		}
	}

	if((largeur%4)==2)
	{	
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(tableaucorr[i*largeur+j]==0)
				{
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
				}
				else
				{
					copie[0]=tableaucorr[i*largeur+j];
					if(copie[0]==10)
						copie[0]=11;
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
				}
			}
				fprintf(nomfichier,"%c",255);
				fprintf(nomfichier,"%c",255);
		}
	}

	if((largeur%4)==3)
	{	
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(tableaucorr[i*largeur+j]==0)
				{
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
				}
				else
				{
					copie[0]=tableaucorr[i*largeur+j];
					if(copie[0]==10)
						copie[0]=11;
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
				}
			}
				fprintf(nomfichier,"%c",255);
				fprintf(nomfichier,"%c",255);
				fprintf(nomfichier,"%c",255);
		}
	}

	fclose(nomfichier);

   	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(entete,taillefichier-tailleimage);
	fread(entete,taillefichier-tailleimage,1,nomfichier);
	fclose(nomfichier);

	nomfichier=fopen("images_traitees/image_disparite_traitee_gris.bmp","w");
	for(i=0;i<taillefichier-tailleimage;i++)
	{
		if(entete[i]==10)
			entete[i]=11;
		fprintf(nomfichier,"%c",entete[i]);
	}

	copie[1]='\0';
	copiecouleur[1]='\0';

	if((largeur%4)==0)
	{	
		for(i=0;i<hauteur;i++)
			{
				for(j=0;j<largeur;j++)
				{
					if(tableaucorr[i*largeur+j]==0)
					{
						copie[0]=tableau_gris[i*largeur+j]/4+191;
						if(copie[0]==10)
							copie[0]=11;
						fprintf(nomfichier,"%c",copie[0]);
						fprintf(nomfichier,"%c",copie[0]);
						fprintf(nomfichier,"%c",copie[0]);
					}
					else
					{
						if(tableaucorr[i*largeur+j]<256)
						{
							copie[0]=tableau_gris[i*largeur+j]/4+191;
							copiecouleur[0]=tableaucorr[i*largeur+j];	
							if(copiecouleur[0]==10)
								copiecouleur[0]=11;
							fprintf(nomfichier,"%c",copiecouleur[0]);
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",0);
						}

						else if(tableaucorr[i*largeur+j]<512)
						{
							copie[0]=tableau_gris[i*largeur+j]/4+191;
							copiecouleur[0]=tableaucorr[i*largeur+j]-256;	
							copie2[0]=copie[0]+copiecouleur[0];
							copie2[0]=copie2[0]/2;
							if(copiecouleur[0]==10)
								copiecouleur[0]=11;
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",copiecouleur[0]);
							fprintf(nomfichier,"%c",0);
						}

						else
						{
							copie[0]=tableau_gris[i*largeur+j]/4+191;
							copiecouleur[0]=tableaucorr[i*largeur+j]-512;	
							copie2[0]=copie[0]+copiecouleur[0];
							copie2[0]=copie2[0]/2;
							if(copiecouleur[0]==10)
								copiecouleur[0]=11;
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",copiecouleur[0]);
						}

					}
				}
			}
	}

	if((largeur%4)==1)
	{	
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(tableaucorr[i*largeur+j]==0)
				{
						copie[0]=tableau_gris[i*largeur+j]/4+191;
						if(copie[0]==10)
							copie[0]=11;
						fprintf(nomfichier,"%c",copie[0]);
						fprintf(nomfichier,"%c",copie[0]);
						fprintf(nomfichier,"%c",copie[0]);
				}
				else
				{
						if(tableaucorr[i*largeur+j]<256)
						{
							copie[0]=tableau_gris[i*largeur+j]/4+191;
							copiecouleur[0]=tableaucorr[i*largeur+j];	
							if(copiecouleur[0]==10)
								copiecouleur[0]=11;
							fprintf(nomfichier,"%c",copiecouleur[0]);
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",0);
						}

						else if(tableaucorr[i*largeur+j]<512)
						{
							copie[0]=tableau_gris[i*largeur+j]/4+191;
							copiecouleur[0]=tableaucorr[i*largeur+j]-256;	
							copie2[0]=copie[0]+copiecouleur[0];
							copie2[0]=copie2[0]/2;
							if(copiecouleur[0]==10)
								copiecouleur[0]=11;
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",copiecouleur[0]);
							fprintf(nomfichier,"%c",0);
						}

						else
						{
							copie[0]=tableau_gris[i*largeur+j]/4+191;
							copiecouleur[0]=tableaucorr[i*largeur+j]-512;	
							copie2[0]=copie[0]+copiecouleur[0];
							copie2[0]=copie2[0]/2;
							if(copiecouleur[0]==10)
								copiecouleur[0]=11;
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",copiecouleur[0]);
						}
				}
			}
				fprintf(nomfichier,"%c",255);
		}
	}

	if((largeur%4)==2)
	{	
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(tableaucorr[i*largeur+j]==0)
				{
						copie[0]=tableau_gris[i*largeur+j]/4+191;
						if(copie[0]==10)
							copie[0]=11;
						fprintf(nomfichier,"%c",copie[0]);
						fprintf(nomfichier,"%c",copie[0]);
						fprintf(nomfichier,"%c",copie[0]);
				}
				else
				{
						if(tableaucorr[i*largeur+j]<256)
						{
							copie[0]=tableau_gris[i*largeur+j]/4+191;
							copiecouleur[0]=tableaucorr[i*largeur+j];	
							if(copiecouleur[0]==10)
								copiecouleur[0]=11;
							fprintf(nomfichier,"%c",copiecouleur[0]);
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",0);
						}

						else if(tableaucorr[i*largeur+j]<512)
						{
							copie[0]=tableau_gris[i*largeur+j]/4+191;
							copiecouleur[0]=tableaucorr[i*largeur+j]-256;	
							copie2[0]=copie[0]+copiecouleur[0];
							copie2[0]=copie2[0]/2;
							if(copiecouleur[0]==10)
								copiecouleur[0]=11;
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",copiecouleur[0]);
							fprintf(nomfichier,"%c",0);
						}

						else
						{
							copie[0]=tableau_gris[i*largeur+j]/4+191;
							copiecouleur[0]=tableaucorr[i*largeur+j]-512;	
							copie2[0]=copie[0]+copiecouleur[0];
							copie2[0]=copie2[0]/2;
							if(copiecouleur[0]==10)
								copiecouleur[0]=11;
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",copiecouleur[0]);
						}
				}
			}
				fprintf(nomfichier,"%c",255);
				fprintf(nomfichier,"%c",255);
		}
	}

	if((largeur%4)==3)
	{	
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(tableaucorr[i*largeur+j]==0)
				{
						copie[0]=tableau_gris[i*largeur+j]/4+191;
						if(copie[0]==10)
							copie[0]=11;
						fprintf(nomfichier,"%c",copie[0]);
						fprintf(nomfichier,"%c",copie[0]);
						fprintf(nomfichier,"%c",copie[0]);
				}
				else
				{
						if(tableaucorr[i*largeur+j]<256)
						{
							copie[0]=tableau_gris[i*largeur+j]/4+191;
							copiecouleur[0]=tableaucorr[i*largeur+j];	
							if(copiecouleur[0]==10)
								copiecouleur[0]=11;
							fprintf(nomfichier,"%c",copiecouleur[0]);
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",0);
						}

						else if(tableaucorr[i*largeur+j]<512)
						{
							copie[0]=tableau_gris[i*largeur+j]/4+191;
							copiecouleur[0]=tableaucorr[i*largeur+j]-256;	
							copie2[0]=copie[0]+copiecouleur[0];
							copie2[0]=copie2[0]/2;
							if(copiecouleur[0]==10)
								copiecouleur[0]=11;
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",copiecouleur[0]);
							fprintf(nomfichier,"%c",0);
						}

						else
						{
							copie[0]=tableau_gris[i*largeur+j]/4+191;
							copiecouleur[0]=tableaucorr[i*largeur+j]-512;	
							copie2[0]=copie[0]+copiecouleur[0];
							copie2[0]=copie2[0]/2;
							if(copiecouleur[0]==10)
								copiecouleur[0]=11;
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",0);
							fprintf(nomfichier,"%c",copiecouleur[0]);
						}
				}
			}
				fprintf(nomfichier,"%c",255);
				fprintf(nomfichier,"%c",255);
				fprintf(nomfichier,"%c",255);
		}
	}

	fclose(nomfichier);
	free(entete);

}
