// stereo2.cpp : Defines the entry point for the console application.
//
//-------------------------------------------------------------------------
//				  PRESENTATION
//-------------------------------------------------------------------------
/* Ce programme va chercher la droite constitue par le plus grand nombre de points  l'aide de la transforme de Hough.
Ces points correspondent  la disparit en fonction du numro de la ligne.
Si la disparit est sur la droite, alors a fait parti du plan, sinon, ce n'est pas le cas (et a peut tre considr comme un obstacle)*/ 

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include<stdlib.h>
#include<process.h>
#include<dos.h>
#include<ctype.h>

double PI=3.14159265359;
void stereo(void);
int recdonneesimage(int);
void remplircouleurs(int *,int);
void initialise (char *,int);
void voter(int *,int *,int,int);
void voter2(int *,int *,int,int,double,double);
double maxilocal(int *,int *,int *,int,int,int);
void correspond(int *,int *,int,int,double);	
void realimage(int *,int,int,int,int,int);
void fin(int *,int *,int *,int,int,int,int);

//-------------------------------------------------------------------------
//				  M A I N
//-------------------------------------------------------------------------
void main (void)
{	
	stereo();
}

//-------------------------------------------------------------------------
//                               STEREOVISION
//---------------------------------------------------------------------------
void stereo (void)
{
	int largeur,hauteur,taillefichier,tailleimage,taille;
	int *disparite;
	int *hough,*vote;
	double m,m1,b;

	largeur=recdonneesimage(0);
	hauteur=recdonneesimage(1);
	taillefichier=recdonneesimage(2);
	tailleimage=recdonneesimage(3);
	taille=largeur*hauteur;

	disparite=(int *) malloc (sizeof(int)*(largeur*hauteur));
	remplircouleurs(disparite,taille);

	printf("                       ETAPE 5\n");
	printf("        Trouver les droites\n\n");
	printf("Transformee de Hough\n");
	vote=(int *) malloc (sizeof(int)*(90*(largeur+hauteur)));
	voter(disparite,vote,largeur,hauteur);
	printf("Recherche des maximums locaux\n");	
	hough=(int *) malloc (sizeof(int)*(90*(largeur+hauteur)));

	m=maxilocal(hough,vote,disparite,largeur,hauteur,1);
	b=maxilocal(hough,vote,disparite,largeur,hauteur,2);
	voter2(disparite,vote,largeur,hauteur,m,b);
	m1=maxilocal(hough,vote,disparite,largeur,hauteur,0);

	printf("Correspondance avec image\n");	
	correspond(hough,disparite,largeur,hauteur,m);	
	printf("Creation de l'image\n");	
	realimage(disparite,largeur,hauteur,taillefichier,tailleimage,0);
	printf("Creation du graphique des droites\n");	
	fin(disparite,hough,vote,largeur,hauteur,taillefichier,tailleimage);
	free(disparite);
	printf("Fin Partie 5 \n\n");
//	getch();
}

//-------------------------------------------------------------------------
//                               RECUPERATION DES DONNEES DU FICHIER
//---------------------------------------------------------------------------
int recdonneesimage(int variable)
{
	FILE *nomfichier;
	int taillefichier,tailleimage,largeur,hauteur;

	nomfichier=fopen("donnees_images/description.txt","r");
	fscanf(nomfichier,"%d",&taillefichier);
	fscanf(nomfichier,"%d",&tailleimage);
	fscanf(nomfichier,"%d",&largeur);
	fscanf(nomfichier,"%d",&hauteur);
	fclose(nomfichier);
	if(variable==0)
		return largeur;
	if(variable==1)
		return hauteur;
	if(variable==2)
		return taillefichier;
	if(variable==3)
		return tailleimage;
	else
		return -1;
}

//-------------------------------------------------------------------------
//                               RECUPERATION DES DISPARITES
//---------------------------------------------------------------------------
void remplircouleurs(int *disparite,int taille)
{
	FILE *nomfichier;
	int i;

		nomfichier=fopen("tableaux/disparite.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&disparite[i]);
		fclose(nomfichier);
}

//-------------------------------------------------------------------------
//                               INITIALISE TABLEAU
//---------------------------------------------------------------------------
void initialise (char *entete, int M)
{
	int	i=0;
	for(i=0;i<M;i++)
		entete[i]='\0';
}

//-------------------------------------------------------------------------
//                             DETERMINATION DES ZONES A TRAITER
//---------------------------------------------------------------------------
void zoneatraiter(int *contour_g,int largeur,int hauteur)
{
	int i,j;
	for(i=0;i<hauteur;i++)
		for(j=0;j<largeur;j++)
		{	
			if((j<2)||(i<2)||(j>largeur-3)||(i>hauteur-3))
				contour_g[i*largeur+j]=255;
		}
}

//-------------------------------------------------------------------------
//                             VOTE
//---------------------------------------------------------------------------
void voter(int *disparite,int *vote,int largeur,int hauteur)
{
	int teta,ro;
	int i,j;
	double m,b,x,temp;

	//initialisation de vote
	for(j=0;j!=90;j++)
		for(i=0;i<(largeur+hauteur);i++)
			vote[j*(hauteur+largeur)+i]=0;

	for(m=-0.2;m>-3;m=m-.1)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(disparite[i*largeur+j]!=0)
				{
					b=(disparite[i*largeur+j]-m*i);
					x=-b/m;				
					temp=atan2(x,b);
					teta=(int)((atan2(x,b)*180)/PI);
					ro=(int)(sin(PI/2-temp)*x);
					vote[teta*(largeur+hauteur)+ro]++;
				}
			}
		}
	}

}


//-------------------------------------------------------------------------
//                             VOTE
//---------------------------------------------------------------------------
void voter2(int *disparite,int *vote,int largeur,int hauteur,double m,double b)
{
	int teta,ro;
	int i,j;
	double x,temp,b2,m3;
	int m2;

	//initialisation de vote
	for(j=0;j!=90;j++)
		for(i=0;i<(largeur+hauteur);i++)
			vote[j*(hauteur+largeur)+i]=0;

	m2=(int)(m*100);
	m=m2%5;
	m=m2-m;
	m=m/100;

	for(m3=-m+.15;m3>-m-.15;m3=m3-.01)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(disparite[i*largeur+j]!=0)
				{
					b2=(disparite[i*largeur+j]-m3*i);
					x=-b2/m3;				
					temp=atan2(x,b2);
					teta=(int)((atan2(x,b2)*180)/PI);
					ro=(int)(sin(PI/2-temp)*x);
					if((b2<b+35)&&(b2>b-35))
						vote[teta*(largeur+hauteur)+ro]++;
				}
			}
		}
	}

}

//-------------------------------------------------------------------------
//                           MAXIMUM LOCAL
//---------------------------------------------------------------------------
double maxilocal(int *hough,int *vote,int *disparite,int largeur,int hauteur,int variable)
{
	int i,j;
	int max=0;
	int tetamax,romax;
	double m,b;

	for(j=0;j<90;j++)
		for(i=0;i<(largeur+hauteur);i++)
			hough[j*(largeur+hauteur)+i]=0;

	//initialisation de vote
	for(j=0;j<90;j++)
	{
		for(i=1;i<(largeur+hauteur)-1;i++)
		{
				hough[j*(largeur+hauteur)+i]=vote[j*(largeur+hauteur)+i];
				if(hough[j*(largeur+hauteur)+i]>max)
					max=hough[j*(largeur+hauteur)+i];
		}
	}

	for(j=0;j<90;j++)
	{
		for(i=1;i<(largeur+hauteur)-1;i++)
		{
				if(hough[j*(largeur+hauteur)+i]<(max/3))
					hough[j*(largeur+hauteur)+i]=0;
		}
	}

	if(variable==1||variable==2)
	{
		for(j=0;j<90;j++)
		{
			for(i=1;i<(largeur+hauteur)-1;i++)
			{
				if(hough[j*(largeur+hauteur)+i]==max)
				{
					tetamax=j;
					romax=i;
				}
			}
		}
		if(variable==1)
			printf("\nEquation du plan : h(%d',%d) -->",tetamax,romax);
		m=0;
		m=tan((tetamax*PI)/180);
		m=1/m;
		b=romax/cos((90-tetamax)*PI/180);
		if(variable==2)
			printf(" y=-%Gx+%G\n",m,b);
	}

	if(variable==0)
	{
		for(j=0;j<90;j++)
		{
			for(i=1;i<(largeur+hauteur)-1;i++)
			{
				if(hough[j*(largeur+hauteur)+i]!=max)
					hough[j*(largeur+hauteur)+i]=0;
			}
		}

		for(j=0;j<90;j++)
		{
			for(i=1;i<(largeur+hauteur)-1;i++)
			{
				if((hough[j*(largeur+hauteur)+i]!=0)&&(hough[j*(largeur+hauteur)+i]>10))
				{
					hough[j*(largeur+hauteur)+i-1]=1;
					hough[j*(largeur+hauteur)+i-2]=1;
					hough[j*(largeur+hauteur)+i+1]=1;
					hough[j*(largeur+hauteur)+i+2]=1;
					hough[(j+1)*(largeur+hauteur)+i-1]=1;
					hough[(j+1)*(largeur+hauteur)+i+1]=1;
					hough[(j-1)*(largeur+hauteur)+i-1]=1;
					hough[(j-1)*(largeur+hauteur)+i+1]=1;
				}
			}
		}
	}

	if(variable==1)
		return m;
	if(variable==2)
		return b;
	return 1;

}

//-------------------------------------------------------------------------
//                           CORRESPONDANCE
//---------------------------------------------------------------------------
void correspond(int *hough,int *disparite,int largeur,int hauteur,double m)
{
	int teta,ro,m2;
	double m3,b,x,temp;
	int i,j;
	int *temporaire;
	temporaire=(int *) malloc (sizeof(int)*(largeur*hauteur));

	for(j=0;j<hauteur;j++)
	{
		for(i=0;i<largeur;i++)
		{
				temporaire[j*largeur+i]=disparite[j*largeur+i];
		}
	}

	m2=(int)(m*100);
	m=m2%5;
	m=m2-m;
	m=m/100;

	for(m3=-m+.15;m3>-m-.15;m3=m3-.01)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(temporaire[i*largeur+j]!=0)
				{
					b=(temporaire[i*largeur+j]-m3*i);
					x=-b/m3;				
					temp=atan2(x,b);
					teta=(int)((atan2(x,b)*180)/PI);
					ro=(int)(sin(PI/2-temp)*x);
					if(hough[teta*(largeur+hauteur)+ro]!=0)
						disparite[i*largeur+j]=-1;
				}
			}
		}
	}

	for(i=0;i<hauteur;i++)
	{
		for(j=0;j<largeur;j++)
		{
			if(disparite[i*largeur+j]!=0&&disparite[i*largeur+j]!=-1)
						disparite[i*largeur+j]=-2;
		}
	}

}

//-------------------------------------------------------------------------
//                             REALISATION IMAGE
//---------------------------------------------------------------------------
void realimage(int *disparite,int largeur,int hauteur,int taillefichier,int tailleimage,int variable)
{
	FILE *nomfichier;
	char *entete;
	unsigned char copie[2],copiecouleur[2];
	int i,j, *tableau_gris;

	entete=(char *) malloc (sizeof(char)*(taillefichier-tailleimage));
	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(entete,taillefichier-tailleimage);
	fread(entete,taillefichier-tailleimage,1,nomfichier);
	fclose(nomfichier);
	
	if(variable==0)
		nomfichier=fopen("images_traitees/image_contour_plan1.bmp","w");

	
	
	for(i=0;i<taillefichier-tailleimage;i++)
	{
		fflush(stdin);
		if(entete[i]==10)
			entete[i]=11;
		fprintf(nomfichier,"%c",entete[i]);
	}

	copie[1]='\0';

	if((largeur%4)==0)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=disparite[i*largeur+j];

				if(copie[0]==0)
				{
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
				}

				else if(copie[0]==255)
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
				}				

				else
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",0);
				}
			}
		}
	}

	if((largeur%4)==1)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=disparite[i*largeur+j];
				if(copie[0]==0)
				{
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
				}

				else if(copie[0]==255)
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
				}				

				else
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",0);
				}
			}
				fprintf(nomfichier,"%c",copie[1]);
		}
	}

	if((largeur%4)==2)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=disparite[i*largeur+j];
				if(copie[0]==0)
				{
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
				}

				else if(copie[0]==255)
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
				}				

				else
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",0);
				}
			}
				fprintf(nomfichier,"%c",copie[1]);
				fprintf(nomfichier,"%c",copie[1]);
		}
	}

	if((largeur%4)==3)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=disparite[i*largeur+j];
				if(copie[0]==0)
				{
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",255);
				}

				else if(copie[0]==255)
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
				}				

				else
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",0);
				}
			}
				fprintf(nomfichier,"%c",copie[1]);
				fprintf(nomfichier,"%c",copie[1]);
				fprintf(nomfichier,"%c",copie[1]);
		}
	}
	fclose(nomfichier);
	free(entete);

	tableau_gris=(int *) malloc (sizeof(int)*(largeur*hauteur));
	nomfichier=fopen("tableaux/niveau_gris_g.txt","r");
	for(i=0;i<largeur*hauteur;i++)
		fscanf(nomfichier,"%d",&tableau_gris[i]);
	fclose(nomfichier);

	entete=(char *) malloc (sizeof(char)*(taillefichier-tailleimage));
	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(entete,taillefichier-tailleimage);
	fread(entete,taillefichier-tailleimage,1,nomfichier);
	fclose(nomfichier);
	
	nomfichier=fopen("images_traitees/image_contour_plan2.bmp","w");
	for(i=0;i<taillefichier-tailleimage;i++)
	{
		if(entete[i]==10)
			entete[i]=11;
		fprintf(nomfichier,"%c",entete[i]);
	}

	copie[1]='\0';
	copiecouleur[1]='\0';

	if((largeur%4)==0)
	{	
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(disparite[i*largeur+j]==0)
				{
					copie[0]=tableau_gris[i*largeur+j]/4+191;
					if(copie[0]==10)
						copie[0]=11;
					fprintf(nomfichier,"%c",copie[0]);
					fprintf(nomfichier,"%c",copie[0]);
					fprintf(nomfichier,"%c",copie[0]);
				}
				if(disparite[i*largeur+j]==-1)
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
				}
				if(disparite[i*largeur+j]==-2)
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",0);
				}

			}
		}
	}

	if((largeur%4)==1)
	{	
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(disparite[i*largeur+j]==0)
				{
					copie[0]=tableau_gris[i*largeur+j]/4+191;
					if(copie[0]==10)
						copie[0]=11;
					fprintf(nomfichier,"%c",copie[0]);
					fprintf(nomfichier,"%c",copie[0]);
					fprintf(nomfichier,"%c",copie[0]);
				}
				if(disparite[i*largeur+j]==-1)
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
				}
				if(disparite[i*largeur+j]==-2)
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",0);
				}

			}
				fprintf(nomfichier,"%c",255);
		}
	}	

	if((largeur%4)==2)
	{	
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(disparite[i*largeur+j]==0)
				{
					copie[0]=tableau_gris[i*largeur+j]/4+191;
					if(copie[0]==10)
						copie[0]=11;
					fprintf(nomfichier,"%c",copie[0]);
					fprintf(nomfichier,"%c",copie[0]);
					fprintf(nomfichier,"%c",copie[0]);
				}
				if(disparite[i*largeur+j]==-1)
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
				}
				if(disparite[i*largeur+j]==-2)
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",0);
				}

			}
				fprintf(nomfichier,"%c",255);
				fprintf(nomfichier,"%c",255);
		}
	}

	if((largeur%4)==3)
	{	
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				if(disparite[i*largeur+j]==0)
				{
					copie[0]=tableau_gris[i*largeur+j]/4+191;
					if(copie[0]==10)
						copie[0]=11;
					fprintf(nomfichier,"%c",copie[0]);
					fprintf(nomfichier,"%c",copie[0]);
					fprintf(nomfichier,"%c",copie[0]);
				}
				if(disparite[i*largeur+j]==-1)
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
				}
				if(disparite[i*largeur+j]==-2)
				{
					fprintf(nomfichier,"%c",0);
					fprintf(nomfichier,"%c",255);
					fprintf(nomfichier,"%c",0);
				}

			}
				fprintf(nomfichier,"%c",255);
				fprintf(nomfichier,"%c",255);
				fprintf(nomfichier,"%c",255);
		}
	}

	fclose(nomfichier);
	free(entete);

}


//-------------------------------------------------------------------------
//                             IMAGE DES DROITES
//---------------------------------------------------------------------------
void fin(int *disparite,int *hough,int *vote,int largeur,int hauteur,int taillefichier,int tailleimage)
{
	FILE *nomfichier;
	char *entete;
	unsigned char copie[2];
	int i,j,taille;

	free(vote);
	free(hough);
	vote=(int *) malloc (sizeof(int)*(largeur*hauteur));
	hough=(int *) malloc (sizeof(int)*(largeur*hauteur));

	for(j=0;j<hauteur;j++)
	{
		for(i=0;i<largeur;i++)
		{
			hough[j*largeur+i]=0;	
		}
	}
	for(j=0;j<hauteur;j++)
		for(i=0;i<largeur;i++)
			vote[j*largeur+i]=0;		

	taille=largeur*hauteur;
	nomfichier=fopen("tableaux/disparite.txt","r");
	for(i=0;i<taille;i++)
		fscanf(nomfichier,"%d",&hough[i]);
	fclose(nomfichier);		

	for(j=0;j<hauteur;j++)
	{
		for(i=0;i<largeur;i++)
		{
			if(hough[j*largeur+i]!=0)
			{
				if(disparite[j*largeur+i]==-1)
					vote[j*largeur+hough[j*largeur+i]*2]=1;
				else
					vote[j*largeur+hough[j*largeur+i]*2]=2;
			}
		}
	}

	
	entete=(char *) malloc (sizeof(char)*(taillefichier-tailleimage));
	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(entete,taillefichier-tailleimage);
	fread(entete,taillefichier-tailleimage,1,nomfichier);
	fclose(nomfichier);

	nomfichier=fopen("images_traitees/graphique.bmp","w");

	for(i=0;i<taillefichier-tailleimage;i++)
	{
		fflush(stdin);
		if(entete[i]==10)
			entete[i]=11;
		fprintf(nomfichier,"%c",entete[i]);
	}

	copie[1]='\0';

	for(i=0;i<hauteur;i++)
	{
		for(j=0;j<largeur;j++)
		{
			copie[0]=vote[i*largeur+j];
			if(copie[0]==0)
			{
				fprintf(nomfichier,"%c",255);
				fprintf(nomfichier,"%c",255);
				fprintf(nomfichier,"%c",255);
			}
			if(copie[0]==1)
			{
				fprintf(nomfichier,"%c",0);
				fprintf(nomfichier,"%c",0);
				fprintf(nomfichier,"%c",255);
			}
			if(copie[0]==2)
			{
				fprintf(nomfichier,"%c",0);
				fprintf(nomfichier,"%c",255);
				fprintf(nomfichier,"%c",0);
			}
		}
		if((largeur%4)==1)
		{
			fprintf(nomfichier,"%c",255);
		}
		if((largeur%4)==2)
		{
			fprintf(nomfichier,"%c",255);
			fprintf(nomfichier,"%c",255);
		}
		if((largeur%4)==3)
		{
			fprintf(nomfichier,"%c",255);
			fprintf(nomfichier,"%c",255);
			fprintf(nomfichier,"%c",255);
		}
	
	}

	fclose(nomfichier);
	free(entete);
	free(vote);
	free(hough);
}
